
#import "ArdnPanel.h"
#import "nxlcau21.h"
#import "nxardn21.h"

extern parneih    amat;
extern parneih    bmat;
extern parneih    fmat;
extern parneih    gmat;
extern parneih    hmat;
extern parneih    xmat;

extern twoparn    tmat;
extern twoparn    umat;
extern twoparn    vmat;

extern double stt, sta[][K3+1];

int    allmoyet=NO;
int    ardnl, ardntl;

@implementation ArdnPanel

/* - - - - - - - - - - - - -   A R D N   P A N E L   - - - - - - - - - - - - */

- loadArdn:sender {
id   ancMen;
  if (ABCWindow==nil) {
    if (![NXApp loadNibSection: "ardn.nib" owner: self withNames: NO]) 
	{return nil;}
    ancMen = [[Menu alloc] initTitle: "Ancestors"];
    [[ancMen 
      addItem: "A,B" 
      action: @selector(makeKeyAndOrderFront:) keyEquivalent: '\0']
        setTarget: ABCWindow];
    [[ancMen 
      addItem: "T Matrix" 
      action: @selector(orderFront:) keyEquivalent: '\0']
        setTarget: tWindow];
    [[ancMen 
      addItem: "Graph" 
      action: @selector(orderFront:) keyEquivalent: '\0']
	setEnabled: NO];
    [[ancMen 
      addItem: "Frequencies" 
      action: @selector(orderFront:) keyEquivalent: '\0']
        setTarget: anWindow];
    [[ancMen 
      addItem: "Variances"
      action: @selector(moments:) keyEquivalent: '\0']
	setTarget: self];
    [[ancMen 
      addItem: "Histogram"
      action: @selector(orderFront:) keyEquivalent: '\0']
        setTarget: histoWindow];
    [[ancMen 
      addItem: "Survey"
      action: @selector(orderFront:) keyEquivalent: '\0']
	setEnabled: NO];
    [[sender window] setSubmenu: ancMen forItem: [sender selectedCell]];
    [[sender selectedCell] performClick: sender];
    }
  return self;
  }

- windowDidBecomeKey:sender {
	[menuCopy setTarget: self];
	[menuCopy setAction: @selector(copyABCBox:)];
	[menuCopy setEnabled: YES];
//	[menuCopyW setTarget: self];
//	[menuCopyW setAction: @selector(copyAncestor:)];
//	[menuCopyW setEnabled: YES];
	[menuPrint setTarget: sender];
	[menuPrint setAction: @selector(smartPrintPSCode:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
	[menuCopy setEnabled: NO];
//	[menuCopyW setEnabled: NO];
	[menuPrint setEnabled: NO];
return self;
}

- copyABCBox:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [[ABCBox contentView] getBounds: &zbounds];
  [[ABCBox contentView] writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

- sPrint:matrix {int i, j;
  for (i=0; i<K2; i++) for (j=0; j<K2; j++)
  [[matrix cellAt:i:j] setDoubleValue: (double)gmat.two[i][j]];
return self;
}

- tPrint:sender {int i, j;
  for (i=0; i<K4; i++) for (j=0; j<K4; j++)
  [[tMatrix cellAt:i:j] setDoubleValue: (double)umat.two[i][j]];
return self;
}

/* this is S, the s precursor */
- moments:sender {int i0, i1, tl;
  [varWindow orderFront: self];
  if (allmoyet) return self;
  [varWindow makeKeyAndOrderFront: self];
  tl=[varText textLength];
  [varText setSel: 0: tl];
  [varText replaceSel: "now computing second moments\n"];
  [varText scrollSelToVisible]; 
  [varText display];
  for (i0=0; i0<5; i0++) for (i1=0; i1<K2+1; i1++) sta[i0][i1]=0.0;
  for (i1=0; i1<K2+1; i1++) sta[3][i1]=10.0;
  stt=0.0;
  allmo();
  allmoyet=YES;
  [self allmoData: self];
printf("allmo done\n");
return self;
}

- reversibles:sender {rever(); return self;}

- squareRoots:sender {
// squrt();
return self;
}

- squaredRules:sender {
// squruls();
return self;
}

- allmoPrint:sender {[varWindow  smartPrintPSCode: self]; return self;}

- allmoData:sender {
char   ch[100];
int    i0, tl;
double f, g, h, e;
//	if (ss==0) {printf("S required first"); break;}
//        printf("      freq,   ave, 2d mom,    var\n");
  [varWindow orderFront: self];
  tl=[varText textLength];
  [varText setSel: 0: tl];
  [varText replaceSel: "      freq,   ave, 2d mom,    var\n"];
  [varText scrollSelToVisible]; 
  [varText display];
	  for (i0=0; i0<K3+1; i0++) {
	    f=sta[0][i0]; if (f>0.0) {
	    g=sta[1][i0]/f;
	    h=sta[2][i0]/f;
	    e=sqrt(h-g*g);
            sprintf(ch,"%1d%1d %6.0f, %6.3f, %6.2f, %6.3f\n",K3-i0,i0,f,g,h,e);
  tl=[varText textLength];
  [varText setSel: tl: tl];
  [varText replaceSel:  ch];
  [varText scrollSelToVisible]; 
  [varText display];
	    }}
	f=sta[0][4]-stt; if (f>0.0) {
	    g=(sta[1][4]-2.0*stt)/f;
	    h=(sta[2][4]-4.0*stt)/f;
	    e=sqrt(h-g*g);
//	    printf("\n");
  tl=[varText textLength];
  [varText setSel: tl: tl];
  [varText replaceSel: "\n"];
  [varText scrollSelToVisible]; 
  [varText display];
	    sprintf(ch,"-- %6.0f, %6.3f, %6.2f, %6.3f\n",f,g,h,e);
  tl=[varText textLength];
  [varText setSel: tl: tl];
  [varText replaceSel:  ch];
  [varText scrollSelToVisible]; 
  [varText display];
	    }
	sprintf(ch,"tt %6.0f, %6.3f, %6.2f, %6.3f\n",stt,2.0,4.0,0.0);
  tl=[varText textLength];
  [varText setSel: tl: tl];
  [varText replaceSel:  ch];
  [varText scrollSelToVisible]; 
  [varText display];
return self;
}

-showHistoGram:sender {
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m4[KK][KK][KK][KK];
int    i, i0, i1, i2, i3, i4, i5, i6, i7;
int    t8[KK][KK][KK][KK][KK][KK][KK][KK];
int    po, da, h8[AV*K8+1];
int    tl;
char   c[30];
double s, t, kk8;

asctobin();
zmat(&amat);  djmat(&amat,0);
zmat(&bmat);  djmat(&bmat,1);

kk8=(double)K8;
cymat(&m1[0],&amat);
cymat(&m1[1],&bmat);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  mmat(&m4[i0][i1][i2][i3],&m2[i0][i1],&m2[i2][i3]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {
  mmat(&xmat,&m4[i0][i1][i2][i3],&m4[i4][i5][i6][i7]);
  t8[i0][i1][i2][i3][i4][i5][i6][i7]=tsum(&xmat);
  }

for (i0=0; i0<AV*K8+1; i0++) h8[i0]=0;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  h8[t8[i0][i1][i2][i3][i4][i5][i6][i7]]++;

po=da=0;
  tl=[histoGram textLength];
  [histoGram setSel: 0: tl];
  [histoGram replaceSel: ""];
for (i=0; i<60; i++)
  {
  po+=h8[i];
  da+=i*h8[i];
  sprintf(c,"%2u %4u %4u\n",i,h8[i],po);
  tl=[histoGram textLength];
  [histoGram setSel: tl: tl];
  [histoGram replaceSel:  c];
  [histoGram scrollSelToVisible]; 
  [histoGram display];
  }

// videocursor(0,22,0);  Printf("total: %3d in %3d pts;",AV*K8,K8);
// videocursor(0,23,0);  Printf("average: %2u",AV);
// videocursor(0,22,23); Printf("beyond: %3d, %3d",AV*K8-da,K8-po);

  [dataList setIntValue: AV*K8 at: 0];
  [dataList setIntValue: K8 at: 1];
  [dataList setIntValue: AV at: 2];
  [dataList setIntValue: AV*K8-da at: 3];
  [dataList setIntValue: K8-po at: 4];

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {t=((double)(t8[i0][i1][i2][i3][i4][i5][i6][i7]-AV)); s+=t*t;}
t=sqrt(s/kk8);
// videocursor(0,23,24); Printf("sigma:   %6.2f",t);

  [dataList setDoubleValue: t at: 5];

   wru(c);
   [ruleNumber setStringValue: c];

return self;
}

- showFrequencies:sender {
char       ch[100];
int        tl;
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m3[KK][KK][KK];
int        i0, i1, i2, i3, i4, i5;
int        t1[KK], t2[KK][KK], t3[KK][KK][KK], t4[KK][KK][KK][KK];
int        t5[KK][KK][KK][KK][KK], t6[KK][KK][KK][KK][KK][KK];
double     s, t, u, kk1, kk2, kk3, kk4, kk5, kk6;

kk1=(double)KK;
kk2=(double)K2;
kk3=(double)K3;
kk4=(double)K4;
kk5=(double)K5;
kk6=(double)K6;

asctobin();
zmat(&amat);  djmat(&amat,0);
zmat(&bmat);  djmat(&bmat,1);

   wru(ch);
   [ruleNumber setStringValue: ch];

  tl=[anFreq textLength];
  [anFreq setSel: 0: tl];
  [anFreq replaceSel:  "ancestor frequencies by configuration\n\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
cymat(&m1[0],&amat);
cymat(&m1[1],&bmat);
t1[0]=tsum(&m1[0]);
t1[1]=tsum(&m1[1]);
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "2 configurations of length 1\n\n"];
  sprintf(ch,"%3d,%3d\n\n",t1[0],t1[1]);
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel:  ch];
  [anFreq scrollSelToVisible]; 
  [anFreq display];

/* 4 configurations of length 2 */

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);
  t2[i0][i1]=tsum(&m2[i0][i1]);
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "4 configurations of length 2\n\n"];
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++) {
  sprintf(ch,"%3d,",t2[i0][i1]);
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel:  ch];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];

/* 8 configurations of length 3 */

  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n8 configurations of length 3\n\n"];
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  mmat(&m3[i0][i1][i2],&m1[i0],&m2[i1][i2]);
  t3[i0][i1][i2]=tsum(&m3[i0][i1][i2]);
  }
for (i0=0; i0<KK; i0++) {
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++) {
    sprintf(ch,"%3d,",t3[i0][i1][i2]);
    tl=[anFreq textLength];
    [anFreq setSel: tl: tl];
    [anFreq replaceSel:  ch];
    [anFreq scrollSelToVisible]; 
    [anFreq display];
    }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];

/* 16 configurations of length 4 */

  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n16 configurations of length 4\n\n"];
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  mmat(&xmat,&m2[i0][i1],&m2[i2][i3]);
  t4[i0][i1][i2][i3]=tsum(&xmat);
  }
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++) {
    sprintf(ch,"%3d,",t4[i0][i1][i2][i3]);
    tl=[anFreq textLength];
    [anFreq setSel: tl: tl];
    [anFreq replaceSel:  ch];
    [anFreq scrollSelToVisible]; 
    [anFreq display];
    }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];

/* 32 configurations of length 5 */

  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n32 configurations of length 5\n\n"];
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {
  mmat(&xmat,&m2[i0][i1],&m3[i2][i3][i4]);
  t5[i0][i1][i2][i3][i4]=tsum(&xmat);
  }
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++) {
  sprintf(ch,"%3d,",t5[i0][i1][i2][i3][i4]);
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel:  ch];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];

/* 64 configurations of length 6 */

  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n64 configurations of length 6\n\n"];
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {
  mmat(&xmat,&m3[i0][i1][i2],&m3[i3][i4][i5]);
  t6[i0][i1][i2][i3][i4][i5]=tsum(&xmat);
  }
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++) {
  sprintf(ch,"%3d,",t6[i0][i1][i2][i3][i4][i5]);
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel:  ch];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];

/* record the six variances */

for (i0=0,s=0.0; i0<KK; i0++) {t=((double)(t1[i0]-AV)); s+=t*t;}
t=sqrt(s/kk1);
// videocursor(0,2,33); printf("%6.2f",t);
  [[anVari cellAt: 0: 0] setDoubleValue: t];

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {t=((double)(t2[i0][i1]-AV)); s+=t*t;}
t=sqrt(s/kk2);
// videocursor(0,4,33); printf("%6.2f",t);
  [[anVari cellAt: 0: 1] setDoubleValue: t];

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {t=((double)(t3[i0][i1][i2]-AV)); s+=t*t;}
t=sqrt(s/kk3);
// videocursor(0,6,33); printf("%6.2f",t);
  [[anVari cellAt: 0: 2] setDoubleValue: t];

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {t=((double)(t4[i0][i1][i2][i3]-AV)); s+=t*t;}
t=sqrt(s/kk4);
// videocursor(0,9,33); printf("%6.2f",t);
  [[anVari cellAt: 0: 3] setDoubleValue: t];

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {t=((double)(t5[i0][i1][i2][i3][i4]-AV)); s+=t*t;}
t=u=sqrt(s/kk5);
// videocursor(0,14,33); printf("%6.2f",t);
  [[anVari cellAt: 0: 4] setDoubleValue: t];

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {t=((double)(t6[i0][i1][i2][i3][i4][i5]-AV)); s+=t*t;}
t=sqrt(s/kk6);
// videocursor(0,23,33); printf("%6.2f",t);
  [[anVari cellAt: 0: 5] setDoubleValue: t];

s=1.0; if (u!=0.0) s=t/u;
// videocursor(0,24,0); printf("ratio: %6.2f",s);
  [anFact setDoubleValue: s];

return self;
}

- ardn:sender {
char   ch[20];
int    a, b, i, j, i0, i1, op;
int    c[KK][KK], r[KK][KK];
int    u[KK][KK], v[KK][KK];
double cc[KK][KK], rr[KK][KK];
double uu[KK][KK], vv[KK][KK];
double s, t, bb, utu, utv, vtv, co;

op=0;

if (strcmp([[lambdaStyle selectedCell] title],"vectors")==0) op=0;
if (strcmp([[lambdaStyle selectedCell] title],"lambda")==0) op=1;
if (strcmp([[lambdaStyle selectedCell] title],"Z")==0) op=2;

if (strcmp([[sender selectedCell] title],"copy A")==0) {
  gmat=amat;
  [self sPrint:pMatrix];
  ardnl=1;
  [aPower setIntValue: ardnl];
  }
if (strcmp([[sender selectedCell] title],"copy B")==0) {
  gmat=bmat;
  [self sPrint:pMatrix];
  ardnl=1;
  [aPower setIntValue: ardnl];
  }
if (strcmp([[sender selectedCell] title],"times A")==0) {
  mmat(&hmat,&amat,&gmat);
  gmat=hmat;
  [self sPrint:pMatrix];
  ardnl++;
  [aPower setIntValue: ardnl];
  }
if (strcmp([[sender selectedCell] title],"times B")==0) {
  mmat(&hmat,&bmat,&gmat);
  gmat=hmat;
  [self sPrint:pMatrix];
  ardnl++;
  [aPower setIntValue: ardnl];
  }
if (strcmp([[sender selectedCell] title],"square")==0) {
  mmat(&hmat,&gmat,&gmat);
  gmat=hmat;
  [self sPrint:pMatrix];
  ardnl*=2;
  [aPower setIntValue: ardnl];
  }
if (strcmp([[sender selectedCell] title],"initialize")==0) {
   wru(ch);
   [ruleNumber setStringValue: ch];
asctobin();
zmat(&amat);  djmat(&amat,0);
zmat(&bmat);  djmat(&bmat,1);
zzmat(&tmat); tensq(&tmat,&amat,&bmat);
unmat(&umat);
  gmat=amat;
  [self sPrint:aMatrix];
  gmat=bmat;
  [self sPrint:bMatrix];
zmat(&gmat);
zmat(&xmat);
  ardnl=0;
  [aPower setIntValue: ardnl];
[[aCimag cellAt: 0: 0] setIntValue: tsum(&amat)];
[[aCimag cellAt: 1: 0] setIntValue: tsum(&bmat)];
  }
if (strcmp([[sender selectedCell] title],"lambda")==0) {
	mmat(&hmat,&gmat,&gmat);
	mmat(&fmat,&hmat,&hmat);
	mmat(&hmat,&fmat,&fmat);
	mmat(&fmat,&gmat,&hmat);
	a=tsum(&hmat);
	b=tsum(&fmat);
        bb=0.0; if (a!=0) bb=((double)(b))/((double)(a));
        [aEigenvalue setDoubleValue:bb];

    s=((double)tsum(&gmat))/((double)K2);    /* gamma = ave. row or col sum */
    t=1.0/((double)K2);                      /* 1/n = ave n'lized component */
    rowsum(u,&fmat);
    rowsum(r,&gmat);
    colsum(v,&fmat);
    colsum(c,&gmat);
    for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
      i=i0+KK*i1;
      uu[i1][i0]=((double)u[i1][i0])/((double)b);
      vv[i1][i0]=((double)v[i1][i0])/((double)b);
      cc[i1][i0]=(double)c[i1][i0];
      rr[i1][i0]=(double)r[i1][i0];
       }
    utu=0.0; utv=0.0, vtv=0.0;
    switch (op) {
    case 0:
      for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
        utu+=uu[i1][i0]*uu[i1][i0];
        utv+=uu[i1][i0]*cc[i1][i0];
        vtv+=cc[i1][i0]*cc[i1][i0];
        }
      break;
    case 1:
      for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
        utu+=(uu[i1][i0]-t)*(uu[i1][i0]-t);
        utv+=(uu[i1][i0]-t)*(cc[i1][i0]-s);
        vtv+=(cc[i1][i0]-s)*(cc[i1][i0]-s);
        }
      break;
    case 2:
      for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
        utu+=(uu[i1][i0]-0.5*t)*(uu[i1][i0]-0.5*t);
        utu+=(0.5*t)*(0.5*t);
        utv+=(uu[i1][i0]-0.5*t)*(cc[i1][i0]-1.0);
        utv-=(0.5*t)*(2.0-cc[i1][i0]-1.0);
        vtv+=(cc[i1][i0]-1.0)*(cc[i1][i0]-1.0);
        vtv+=(2.0-cc[i1][i0]-1.0)*(2.0-cc[i1][i0]-1.0);
        }
      break;
    default: break;}
    utu=sqrt(utu); vtv=sqrt(vtv);
    co=utv/(utu*vtv);
    for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
      i=i0+KK*i1;
      [[aColumn cellAt:i:0] setDoubleValue:uu[i1][i0]];
      [[aRow cellAt:0:i] setDoubleValue:vv[i1][i0]];
      [[aColumnR cellAt:0:i] setDoubleValue:cc[i1][i0]];
      [[aRowR cellAt:i:0] setDoubleValue:rr[i1][i0]];
      if (op==1) [sigmaC setDoubleValue:0.5*vtv];
      if (op==2) [sigmaC setDoubleValue:0.353*vtv];
      if (op==1) [sigmaX setDoubleValue:0.5*utu];
      if (op==2) [sigmaX setDoubleValue:0.353*utu];
      [aCosine setDoubleValue: co];
      [aTheta setDoubleValue: (180.0*acos(co))/3.14159];
      }
        }
return self;
}

- printPlain:sender {[wholePanel smartPrintPSCode: self]; return self;}

- arsq:sender {
int    op;
char   ch[20];
double f, ff, g, gg, gl, gr, t, tt, h, kay;

op=0;
  [tPower setIntValue: ardntl];

if (strcmp([[sender selectedCell] title],"initialize")==0) {
   wrru(ch);
   [tRuleNumber setStringValue: ch];
   [tEigenvalue setStringValue: ""];
asctobin();
zmat(&amat);  djmat(&amat,0);
zmat(&bmat);  djmat(&bmat,1);
zzmat(&tmat); tensq(&tmat,&amat,&bmat);
unmat(&umat);
zmat(&gmat);
zmat(&xmat);
  }
if (strcmp([[sender selectedCell] title],"t matrix")==0) {
  umat=tmat;
  ardntl=1;
  [tPower setIntValue: ardntl];
  }
if (strcmp([[sender selectedCell] title],"times t")==0) {
  mmmat(&vmat,&tmat,&umat);
  umat=vmat;
  ardntl++;
  [tPower setIntValue: ardntl];
  }
if (strcmp([[sender selectedCell] title],"square")==0) {
  mmmat(&vmat,&umat,&umat);
  umat=vmat;
  ardntl+=ardntl;
  [tPower setIntValue: ardntl];
  }
if (strcmp([[sender selectedCell] title],"lambda")==0) {
  t=ttsum(&umat);
  f=(double)t;
  mmmat(&vmat,&tmat,&umat);
  t=ttsum(&vmat);
  ff=f; f=(double)t;
  h=h*kay;
  gg=g; g=f/h;
  [tEigenvalue setDoubleValue: f/ff];
  gr=g/gg; gl=0.0; if (gr>0.0) gl=log(gr);
  tt=1;
  }

//	auua(&xave,&xsig,&ex,&wy,cvec,xvec,umat);

    [self tPrint: self];

return self;
}

@end

/* end ArdnPanel.m */