
/* 
 * LCAUView.h -- Interface file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use.
 *
 */

#import <appkit/appkit.h>

@interface LCAUView:View {

	id		aSwitch;
	id		ruleSamples;
	id		forGens;
	id		gridSize;
	id		dataList;
	id		rbutton,sbutton;
	id		ruleNumber;
	id		tiDat;
	id		valBx;
	id		varText;
	id		varWindow;
	
	id		baysRule;
	id		baysCoef;
	id		bernEdge;
	id		bernGens;
	id		bernProb;
	
	id		menuCopy;
	id		menuPrint;

	id		theEvolView;
	id		thePlaidView;
	id		theShEvolView;
	id		theThEvolView;

	id		evolWindow;
	id		keyWindow;
	id		shEvolWindow;
	id		thEvolWindow;
	id		plaidWindow;
	
	id		delegate;
	id		crossCursor;
        
/* ------------ evolution ---------------*/

	id		keepTop;

}

- bernstein:sender;
- g2mc:sender;
- crossSection:sender;
- print3:sender;
- clearRules:sender;
- copyShEvol:sender;
- copyThEvol:sender;
- drawEvolu:sender;
- drawShEvol:sender;
- drawThEvol:sender;
- printEvolu:sender;
- setStatep:sender;
- showLine:sender;
- makeline:sender;
- manyGens:sender;

- drawPlaid:sender;
- printPlaid:sender;
- printShEvol:sender;
- printThEvol:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;

@end

/* end LCAUView.h */
