
/* 
 * LCAUView.m -- Implementation file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import "LCAUView.h"
#import "drawingFuncs.h"
#import "nxlcau21.h"
#import <math.h>
#import <dpsclient/psops.h>
#import <dpsclient/wraps.h>
#import <stdlib.h>
#import <string.h>

extern NXColor  colst[KK];

int    drawBack=YES;
int    drawBern=NO;
int    drawCross=NO;
int    drawMonc=NO;
int    drawEvol=NO;
int    drawLine=NO;
int    drawReturn=NO;
int    drawShort=NO;
int    drawThird=NO;
int    drawPlaid=NO;

int    drawview=0;

int    plaidline[2];

int    srule[2][27];
int    life[20*20*20], ljfe[20*20*20];
int    save1[20][20], save2[20][20], save3[20][20];
int    cu=12;
double berns[27], pasc[27];

extern char   arule[DS], arr1[AL], arr2[AL];

extern char ascrule[KK][KK][KK];
extern char auxrule[KK][KK][KK];

extern  void savearry();
extern  void asctobin();
extern  void onegen(int);
extern  void renewarry();
extern  void ranlin(double);
extern  void xblnk();
extern       linix(int,int,int,int);
extern  void edijn();
extern  void edshf(int,int,int);
extern  void rule22();
extern  void evolve(int);
extern       pgrid();
extern       pprob();
extern  void procur(int,int);
extern  void twoblockfreq(int);
extern  void nblcur(int);
extern  void neisum(int,int,int);
extern  void gnlsum(int,int,int);
extern  void ijn(int,int,int);
extern  void edshg(int,int);
extern  int  nearest(double,double);
extern  void   wru(char *c); 
extern  float  getNumber(NXStream *stream);
extern  int    getSeparator(NXStream *stream);
extern  void egraf(int n);
extern  void lifreq(int n, int l);
void   serms(double x, double y, int l, int m);
void   shortevolve(int m, int n);
void   nxlcau21();
double bdist(int i, int j, int n);
void   wru(char *c);

#define AYEL 34

@implementation LCAUView

void videocursor(p,i,j) int p, i, j; {}
void videoputc(c,i) char c; int i; {}
void videomode(i) int i; {}
void videopalette(i) int i; {}
void videoscroll(i,j,k,l,d,c) int i, j, k, l, d, c; {}
void videocattr(p,c,n,l) int p, c, n, l; {}


void videodot(i,j,l) int i, j, l; {

       if (l<2) NXSetColor(colst[l]);
  else if (l==2) NXSetColor(NX_COLORBLUE);
  else if (l>2) NXSetColor(NX_COLORBLACK);

    switch (drawview) {
      case 0: PSrectfill(2.0*(float)j,2.0*(float)i,1.25,1.25); break;
      case 1: PSrectfill(2.0*(float)j,200.0-2.0*(float)i,1.25,1.25); break;
      case 2: PSrectfill(8.0*(float)j+1.5,60.0-8.0*(float)i,4.75,4.75); break;
      case 3: PSrectfill(4.0*(float)j+2.0,48.0-4.0*(float)i,3.0,3.0); break;
      case 4: PSrectfill(2.0*(float)j,2.0*(float)i,1.25,1.25); break;
      case 5: PSrectfill(2.0*(float)j,2.0*(float)i,1.5,1.5); break;
      case 6: PSrectfill(10.0*(float)j,10.0*(float)i,9.0,9.0); break;
      case 7: PSrectfill(4.0*(float)j,4.0*(float)i,3.125,3.125); break;
      case 8: PSrectfill(j,i,1.5,1.5);break;
      default: break;}
   
}

/* m = line length; n = number of lines */

void shortevolve(m,n) int m, n; {
int i, j, o;
  savearry();
  asctobin();
  o=AL/2-m/2;
  for (j=0; j<n; j++) {
    for (i=0; i<m; i++) videodot(j,i,arr1[i+o]);
    onegen(AL);
    }
  renewarry();
}

/* index three dimensions */
int ix3(i,j,k) int i, j, k; 
{return (cu+i)%cu+ cu*((cu+j)%cu+ cu*((cu+k)%cu ));}

void ranlife(pee) double pee; {int i, p;
p=(int)(10000.0*pee);
for (i=0; i<cu*cu*cu; i++) if (rand()%10000<p) life[i]=1; else life[i]=0;
}

double evlife() {
int    i, j, k, a, b, c, s, t, o, p, q;
double pee;
p=0;
for (i=0; i<cu; i++) for (j=0; j<cu; j++) for (k=0; k<cu; k++) {
  s=0; 
  for (a=-1; a<2; a++) for (b=-1; b<2; b++) for (c=-1; c<2; c++)
    s+=life[ix3(i+a,j+b,k+c)];
  t=life[ix3(i,j,k)]; s-=t;
  o=srule[t][s];
  ljfe[ix3(i,j,k)]=o;
  p+=o;
  }
for (i=0; i<cu*cu*cu; i++) life[i]=ljfe[i];
q=(double)cu;
pee=((double)p)/(q*q*q);
return pee;
}

double bdist(i,j,n) int i, j, n; {int a[10], b[10], l, m; double kay, s, t;
  kay=((double)KK);
  for (l=0; l<n; l++) a[l]=b[l]=0;
  for (m=i, l=0; l<n; m/=KK, l++) a[l]=m%KK;
  for (m=j, l=0; l<n; m/=KK, l++) b[l]=m%KK;
  for (s=0.0, t=1.0, l=0; l<n; t*=kay, l++) {if (a[l]!=b[l]) s+=t;}; 
  return s/t;
}
      
/* --------------------------- E V O L U T I O N --------------------------- */

- drawShEvol:sender {
    drawview=7;
    drawShort=YES;
    [self display];
    drawShort=NO;

return self;
}

- printShEvol:sender {
    drawview=7;
    drawShort=YES;
    [keyWindow smartPrintPSCode: self];
    drawShort=NO;
return self;
}

- drawThEvol:sender {
    [thEvolWindow makeKeyAndOrderFront: self];
    drawview=6;
    drawThird=YES;
    [thEvolWindow display];
    drawThird=NO;
return self;
}

- printThEvol:sender {
    drawview=6;
    drawThird=YES;
    [keyWindow smartPrintPSCode: self];
    drawThird=NO;
return self;
}

- printLCAU:sender {
    if (keyWindow==shEvolWindow)  [self printShEvol:  sender];
    if (keyWindow==thEvolWindow)  [self printThEvol:  sender];
    if (keyWindow==evolWindow)    [self printEvolu:   sender];
    if (keyWindow==plaidWindow)   [self printPlaid:   sender];
return self;
}

- windowDidBecomeKey:sender {
	keyWindow=sender;
	[menuCopy setTarget: self];
	[menuCopy setAction: @selector(copyLCAU:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: self];
	[menuPrint setAction: @selector(printLCAU:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
	[menuCopy setEnabled: NO];
	[menuPrint setEnabled: NO];
return self;
}

- copyShEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=7;
  drawShort=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theShEvolView getBounds: &zbounds];
  [theShEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawShort=NO;
return self;
}

- copyThEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=6;
  drawThird=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theThEvolView getBounds: &zbounds];
  [theThEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawThird=NO;
return self;
}

- copyEvolu:sender {
NXRect zbounds;
id     pBoard;
  drawview=7;
  drawShort=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theShEvolView getBounds: &zbounds];
  [theShEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawShort=NO;
return self;
}

- copyLCAU:sender {
    if (keyWindow==shEvolWindow)  [self copyShEvol: sender];
    if (keyWindow==thEvolWindow)  [self copyThEvol: sender];
    if (keyWindow==evolWindow)    [self copyEvolu:  sender];
    if (keyWindow==plaidWindow)   [self copyPlaid:  sender];
return self;
}

- drawEvolu:sender {
  drawview=0;
  drawEvol=YES;
  [self display];
  drawEvol=NO;
return self;
}

- printEvolu:sender {
  drawview=0;
  drawEvol=YES;
  [keyWindow smartPrintPSCode: self];
  drawEvol=NO;
return self;
}

- drawPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
  [self display];
  drawPlaid=NO;
  [self setFlipped: YES];
return self;
}

- printPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
    [keyWindow smartPrintPSCode: self];
  drawPlaid=NO;
  [self setFlipped: YES];

return self;
}

/* --------------------------- B E R N S T E I N --------------------------- */

- clearRules:sender {int i;
for (i=0; i<27; i++) [[baysRule cellAt:0:i] setIntValue:0];
for (i=0; i<27; i++) [[baysRule cellAt:1:i] setIntValue:0];
return self;
}

- bernstein:sender {
  drawview=5;
  drawBern=YES;
  [self display];
  drawBern=NO;
return self;
}

- returnMap:sender {
  drawview=5;
  drawReturn=YES;
  [self display];
  drawReturn=NO;
return self;
}

- crossSection:sender {int k;
  drawview=5;
  drawCross=YES;
  for (k=0; k<10; k++) [self display];
  drawCross=NO;
return self;
}

- print3:sender
{int i, j;
  evlife();
  for (i=0; i<cu; i++) for (j=0; j<cu; j++) save1[i][j]=life[ix3(i,5,j)];
  evlife();
  for (i=0; i<cu; i++) for (j=0; j<cu; j++) save2[i][j]=life[ix3(i,5,j)];
  evlife();
  for (i=0; i<cu; i++) for (j=0; j<cu; j++) save3[i][j]=life[ix3(i,5,j)];

  for (i=0; i<cu; i++) {
    for (j=0; j<cu; j++) printf("%1d ",save1[i][j]);
    printf("     ");
    for (j=0; j<cu; j++) printf("%1d ",save2[i][j]);
    printf("     ");
    for (j=0; j<cu; j++) printf("%1d ",save3[i][j]);
    printf("\n");
    }
return self;
}

- g2mc:sender {
  drawview=5;
  drawMonc=YES;
  [self display];
  drawMonc=NO;

return self;
}

/* -------------------------------- L C A U -------------------------------- */
  
/* - - - - moved to RulePanel.m - - - - */

/* -------------------------------- A R D N -------------------------------- */

/* - - - - moved to ArdnPanel.m - - - - */

/* -------------------------------- R I J N -------------------------------- */

/* - - - - moved to LiulGuph.m - - - - */

/* -------------------------------- P R O B -------------------------------- */

/* - - - - moved to ProbView.m - - - - */

/* -------------------------------- * * * * -------------------------------- */

/* --------------------------   L C A U    V I E W   ----------------------- */


- initFrame:(const NXRect *)frameRect
/*
 * Initializes the new LCAUView object.  First, an initFrame: message is sent 
 * to super to initialize LCAUView as a View.  Next, the LCAUView sets its own 
 * state -- that it is opaque and that the origin of its coordinate system lies 
 * in the center of its area.  It then creates and initializes its associated 
 * objects, a Storage object, an NXCursor, and a Cell.  Finally, it loads into 
 * the Window Server some PostScript procedures that it will use in drawing 
 * itself. 
 */
{
	NXPoint	spot;
	[super initFrame:frameRect];
/*	[self translate: 
		floor(frame.size.width/2) :floor(frame.size.height/2)]; */
	[self setOpaque:YES];
	crossCursor = [NXCursor newFromImage: 
		[NXImage newFromSection: "cross.tiff"]];
	spot.x = spot.y = 7.0;
	[crossCursor setHotSpot:&spot];
  [self setFlipped: YES];
	return self;

}


- setDelegate:anObject
/*
 * Sets the LCAUView's delegate instance variable to the supplied object.
 */
{
	delegate = anObject;
	return self;
}


- drawSelf:(const NXRect *)rects :(int)rectCount
/*
 * Draws the LCAUView's background and axes.  If there are any points,
 * these are drawn too.
 *
 * (Note:  For simplicity, although LCAUView only repaints the background 
 * of the update region, it redraws the entire axes.  For better performance, 
 * only those parts of the axes that fall within the update region should 
 * be redrawn.)   
 */
{
        char             c[WNML];
	unsigned int	 i, j, k=0,  n=0;
        double           p, q, s, dp, pee, cue, r;
	NXPoint		 *aPoint;
	NXRect		 plotRect;

	
	if (rects == NULL) return self;

	/* paint visible area white then draw axes */
	PSsetgray(NX_WHITE);
	if (drawBack) NXRectFill(&rects[0]);
	PSsetgray(NX_DKGRAY);

   wru(c);
   [ruleNumber setStringValue: c];


        if (drawEvol==YES) {
	  if ([keepTop state]) savearry();
	  evolve(0);
	  if ([keepTop state]) renewarry();
	  }

        if (drawShort==YES) {
   	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/4.0);
	  j=(int)(plotRect.size.height/4.0);
	  shortevolve(i,j);
	  }

        if (drawThird==YES) {
  	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/10.0);
	  j=(int)(plotRect.size.height/10.0);
	  shortevolve(i,j);
	  }

/*--------------------  plaid ----------------------*/
	
	if (drawPlaid==YES) {}

/*------------------------------------------------*/

        if (drawLine==YES) {
        for (j=0; j<8; j++) for (i=0; i<40; i++) videodot(j,i,arr1[i+40*j]);
	}

        if (drawBern==YES) {
for (i=0; i<27; i++) pasc[i]=0.0;
pasc[26]=1.0;
for (j=0; j<26; j++) for (i=0; i<26; i++) pasc[i]=pasc[i]+pasc[i+1];
for (i=0; i<27; i++) [[baysCoef cellAt:i:0] setDoubleValue:pasc[i]];

dp=0.01; p=0.0;
for (k=0, p=0.0; k<101; k++, p+=dp) {
  q=1.0-p;
  for (i=0; i<27; i++) berns[i]=1.0;
  for (i=0, s=1.0; i<27; i++, s*=p) berns[i]*=s;
  for (i=0, s=1.0; i<27; i++, s*=q) berns[26-i]*=s;
//  for (i=0; i<27; i++) [[baysCoef cellAt:i:0] setDoubleValue:berns[i]];

  for (i=0, s=0.0; i<27; i++) 
      s+=([[baysRule cellAt:0:i] doubleValue]*q+
          [[baysRule cellAt:1:i] doubleValue]*p)*berns[i]*pasc[i];
  videodot((int)(200.0*s),2*k,2);
  videodot(2*k,2*k,3);
     }
for (i=0; i<11; i++) for (j=0; j<11; j++) videodot(20*i,20*j,3);
}


        if (drawReturn==YES) {
if (strcmp([[bernEdge selectedCell] title],"8")==0) cu=8;
if (strcmp([[bernEdge selectedCell] title],"12")==0) cu=12;
if (strcmp([[bernEdge selectedCell] title],"20")==0) cu=20;
if (strcmp([[bernGens selectedCell] title],"10")==0) k=10;
if (strcmp([[bernGens selectedCell] title],"20")==0) k=20;
if (strcmp([[bernGens selectedCell] title],"50")==0) k=50;
if (strcmp([[bernGens selectedCell] title],"100")==0) k=100;
pee=[bernProb doubleValue];
ranlife(pee);
  for (i=0; i<2; i++) for (j=0; j<27; j++)
    srule[i][j]=[[baysRule cellAt:i:j] intValue];

for (i=0; i<k; i++) {
  cue=evlife();
//  videodot((int)(200.0*pee),(int)(200.0*cue),3);
  videodot((int)(200.0*pee),2*i,3);
  pee=cue;
  }
}


	if (drawCross==YES) {
    cu=atoi([[bernEdge selectedCell] title]);
// if (strcmp([[bernEdge selectedCell] title],"8")==0) cu=8;
// if (strcmp([[bernEdge selectedCell] title],"12")==0) cu=12;
// if (strcmp([[bernEdge selectedCell] title],"20")==0) cu=20;
    evlife();
    for (i=0; i<cu; i++) for (j=0; j<cu; j++)
      videodot(3*j,3*i,life[ix3(i,5,j)]==1?3:0);
  }

	if (drawMonc==YES) {
    for (i=0; i<100; i++) {
      ranlife(0.01*(double)i);
      cue=evlife();
      videodot((int)(200.0*cue),2*i,3);
      cue=evlife();
      videodot((int)(200.0*cue),2*i,1);
      cue=evlife();
      videodot((int)(200.0*cue),2*i,2);
      }
}

	return self;
}

- sizeTo:(NXCoord)width :(NXCoord)height
/*
 * Ensures that whenever the LCAUView is resized, the origin of its 
 * coordinate system is repositioned to the center of its area.
 */
{
//	  [self setFlipped: YES];
	[super sizeTo:width :height];
	if (drawview==4||drawview==6||drawview==7) 
		{[self setDrawOrigin:0 :0]; return self;}
	else 
		[self setDrawOrigin: -floor(width/2): -floor(height/2)]; 
	return self;
}

- mouseDown:(NXEvent *) theEvent
/*
 * Responds to a message the system sends whenever the user presses the mouse
 * button when the cursor is over the LCAUView.  The LCAUView changes the 
 * cursor to a cross-hairs image and then starts asking for mouse-dragged or 
 * mouse-up events.  As it receives mouse-dragged events, the LCAUView updates 
 * the readOut text Cell with the cursor's coordinates.  If the user releases 
 * the mouse button while the cursor is over the LCAUView, the LCAUView 
 * registers the point and then sends a message to its delegate notifying it 
 * of the new point.
 */
{
	int	looping = YES, oldMask;
	NXPoint	aPoint;
	NXRect	plotRect;

         double  ex, wy;
	 int k;

	[crossCursor set];
   	[self getBounds:&plotRect];

	oldMask = [window addToEventMask:NX_MOUSEDRAGGEDMASK];
 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
				k=nearest(ex,wy);

//       if (theEvent->data.mouse.click==3) {} else 
//       if (theEvent->data.mouse.click==2) {snod=k;} else 
	{
	[self lockFocus];
//         PSsetinstance(YES);
	do {
// 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
//                ex=aPoint.x;
//                wy=aPoint.y;
                plaidline[0]= (int)aPoint.x; 
		plaidline[1]= (int)aPoint.y;
				PSsetgray(NX_BLACK);
//				PSmoveto(ex+12.0,wy);
//				PSarc(ex, wy, 12.0, 0.0, 360.0);
//				PSstroke();
//				cntr[k][0]=ex;
//				cntr[k][1]=wy;
		[window flushWindow];
		if (theEvent->type == NX_MOUSEUP) {
	/* on mouse-up, register point, inform delegate, and clean up state */
			[window flushWindow];
			looping = NO;
		}	
   	} while (looping && (theEvent = 
		[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


	}
	[window setEventMask:oldMask];
	[NXArrow set];
	return self;
}

@end

/* end LCAUView.m */
