
/* 
 * OneRoot.m -- Implementation file for the OneRoot class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to its
 * fitness for any particular use, nor even that it has a use.
 *
 */

#import "OneRoot.h"

@implementation OneRoot


- whoMe:sender {return self;}
- whoView:sender {return cyclView;}
- whoWindow:sender {return cyWindow;}
- thouArt:(int)i {component=i; return self;}

/* - - - - - - - - - - - - - -   O N E R O O T   - - - - - - - - - - - - - */

/* put up the principal window for the CycleView. Since oneroot.nib is a   */
/* tertiary .nib file, it is not loaded until there is a demand, which     */
/* would usually arise from using the cycle browser in CycleView.m.	   */

- oneRoot:sender {
  [NXApp loadNibSection: "oneroot.nib" owner: self withNames: NO]; 
  [cycleWindow orderFront: nil];
  return oneRoot;
  }

- drawSelf:(const NXRect *)rects :(int)rectCount {
  [super mouzeDown: component];
  [super drawSelf: rects: rectCount];
  return self;
}

- mouseDown:(NXEvent *)theEvent {
  [super mouzeDown: component];
  [super mouseDown: theEvent];
  return self;
}

@end

/* end OneRoot.m */
