
/* 
 * ProbView.h -- Interface file for the ProbView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use.
 *
 */

#import <appkit/appkit.h>

@interface ProbView:View {

	id		statEnpai;
	id		statEntro;
	id		statLines;
	id		statMode;
	id		statPair;
	id		statProd;
	id		statRule;
	id		statState;
	id		statSDevi;
	id		statNhood;
	id		statIndx;
	id		statLamb;

	id		tiDat;
	id		valBx;
	
	id		trivEntro;
	id		trivIndx;
	id		trivLamb;
	id		trivPairs;
	id		trivPEntro;
	id		trivProds;
	id		trivState;

	id		rulePanel;

/*  general evolution windows	*/

	id		theBernView;
	id		theBlockView;
	id		theEntropyView;
	id		thePlaidView;
	id		theProbView;
	id		theStatView;
	id		theTwoBView;

	id		bernMatrix;

	id		bernWindow;
	id		blockWindow;
	id		entropyWindow;
	id		keyWindow;
	id		probWindow;
	id		plaidWindow;
	id		statWindow;	
	id		trivWindow;	
	id		twoBWindow;
	
	id		tblokGrid;
	id		tblokCtur;
	id		tblokDiag;
	id		tblokHowMany;
	id		tblokPara;

	id		nblokAve;
	id		nblokLen;
	id		probEI;
	id		probGens;
	id		probHowMany;

	id		menuCopy;
	id		menuPrint;

	id		delegate;
	id		points;
	id		crossCursor;
	id		readOut;
	float		radius;
	BOOL		needsClearing;

}

- clearScreen:sender;
- copyAProbView:sender;
- loadProb:sender;
- printAProbWindow:sender;
- prob:sender;

- drawBern:sender;
- drawBlock:sender;
- drawEntropy:sender;
- drawNBlock:sender;
- drawProb:sender;
- drawStat:sender;

- printBern:sender;
- printBlock:sender;
- printNBlock:sender;
- printPlain:sender;
- printProb:sender;
- printStat:sender;

- copyRule:sender;
- enterBern:sender;
- resetBern:sender;

- nxasfreq:sender;
- nxmoncar:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;

@end

/* end ProbView.h */
