
/* nxardn21.c						*/
/* program for lcau21 option 'e'			*/
/* Garden of Eden and counterimage calculations		*/
/* Harold V. McIntosh, 10 February 1990			*/
/* adapted for NeXTSTEP 5 May 1994			*/

/*  Copyright (C) 1990	*/
/*  Copyright (C) 1994	*/
/*  Harold V. McIntosh	*/

# include <math.h>
# include "nxlcau21.h"
# include "nxardn21.h"
#import <dpsclient/psops.h>


extern void videomode(int i);
extern void videopalette(int i);
extern void scrrul();
extern void videocursor(int p,int i,int j);
extern void woruno(int i, int j);
extern void videoscroll(int i,int j,int k,int l,int d,int c); 
extern  void asctobin();
extern void videoputc(char c, int i);
extern void videodot(int i,int j,int l);
extern char kbdin();
extern printf();
extern sprintf();

extern int  binrule[KK][KK][KK];

char lbuf[81];

extern  parneih    amat;
extern  parneih    bmat;
extern  parneih    fmat;
extern  parneih    gmat;
extern  parneih    hmat;
extern  parneih    xmat;

extern  twoparn    tmat;
extern  twoparn    umat;
extern  twoparn    vmat;


double stt, sta[5][K3+1];

/* edit the Garden of Eden and ancestor screen */
void edard() {
char c;
int    l, ll, m;
int    i0, i1;
int    s0, s1;
int    t0, t1;
int    ss, tt;
double bb, e, f=0.0, g=0.0, h=0.0, ff, gg;
double  kay, kk4;
double ex, wy, go, gr, gl;
double cave, csig, xave, xsig; 
double cvec[K4], xvec[K4];
unsigned int a, b, s, t;
unsigned int tsum(), ttsum();
unsigned int nzel(), nnzel();

videomode(COLGRAF);
videopalette(YELREGR);
videocursor(0,0,0);
scrrul();
woruno(0,22);
videoscroll(1,0,24,39,0,0);
asctobin();
zmat(&amat);  djmat(&amat,0);
zmat(&bmat);  djmat(&bmat,1);
zzmat(&tmat); tensq(&tmat,&amat,&bmat);
unmat(&umat);
zmat(&gmat);
zmat(&xmat);
stt=0.0;
kk4=(double)K4;
l=m=ss=tt=ll=0;
kay=(double)KK;
s0=nzel(&amat);
t0=tsum(&amat);
s1=nzel(&bmat);
t1=tsum(&bmat);
clard();
videocursor(0,14,0); 
sprintf(lbuf,"a=%3u, b=%3u",t0,t1); PSshow(lbuf);
  while (0<1) {
  videocursor(0,0,36);  videoputc('?',2);
  c=kbdin();
  if (c=='\015') break;
  videocursor(0,0,38);  videoputc(c,2);
  videocursor(0,0,36);  videoputc(' ',2);
  videocursor(0,0,0);
  switch (c) {

    case 'a':
	l=1;
	gmat=amat;
	pmat(&gmat,8,5);
	videocursor(0,14,0); sprintf(lbuf,"%4u (%2u) %5u",t0,s0,1); 		PSshow(lbuf);
	break;
    case 'b':
	l=1;
	gmat=bmat;
	pmat(&gmat,8,5);
	videocursor(0,14,0);
 	printf("%4u (%2u)",t1,s1);
	break;
    case 'x':
	l=m;
	gmat=xmat;
	pmat(&gmat,8,5);
	t=tsum(&gmat);
	s=nzel(&gmat);
	videocursor(0,14,0); 
	printf("%4u (%2u)",t,s);
	break;
    case 'h': histo(&amat,&bmat); break;
    case 'j': rvers(&amat,&bmat); break;
    case 'l':
	mmat(&hmat,&gmat,&gmat);
	mmat(&fmat,&hmat,&hmat);
	mmat(&hmat,&fmat,&fmat);
	mmat(&fmat,&gmat,&hmat); 
	a=tsum(&hmat);
	b=tsum(&fmat);
	pmat(&gmat,8,5);
        bb=0.0; if (a!=0) bb=((double)(b))/((double)(a));
	videocursor(0,18,0); printf("%3u %3u",a,b);
	videocursor(0,20,0); printf("  %6.3f",bb);
	break;
    case 'r': rever(); break;
    case 's':
	videoscroll(1,0,24,39,0,0);
	videocursor(0,1,0);
	if (ss==0) {printf("S required first"); break;}
        printf("      freq,   ave, 2d mom,    var\n");
	  for (i0=0; i0<K3+1; i0++)
	    {f=sta[0][i0]; if (f>0.0) {
	    g=sta[1][i0]/f;
	    h=sta[2][i0]/f;
	    e=sqrt(h-g*g);
            printf("%1u%1u %6.0f, %6.3f, %6.2f, %6.3f\n",K3-i0,i0,f,g,h,e);
	    }}
	f=sta[0][4]-stt; if (f>0.0) {
	    g=(sta[1][4]-2.0*stt)/f;
	    h=(sta[2][4]-4.0*stt)/f;
	    e=sqrt(h-g*g);
	    printf("\n");
	    printf("-- %6.0f, %6.3f, %6.2f, %6.3f\n",f,g,h,e);
	    }
	printf("tt %6.0f, %6.3f, %6.2f, %6.3f\n",stt,2.0,4.0,0.0);
	break;
    case 't':
	ll=1;
	ppmat(&tmat,5,21);
	qqmat(&tmat,150,50);
	ccymat(&umat,&tmat);
	t=ttsum(&tmat);
	s=nnzel(&tmat);
	f=(double)t;
	g=f/kay;
	h=kay;
	videocursor(0,22,25); printf("t=%3u, s=%3u ",t,s);
	f=(double)t;
	break;
    case 'u':			/* variance of eigenvector components	*/
	if (tt==0) {videocursor(0,1,0); printf("T required first"); break;}
	auua(&xave,&xsig,&ex,&wy,cvec,xvec,&umat);
	videocursor(0,22,0); printf("av%6.3f, va%6.3f",xave,xsig);
	videocursor(0,24,0); printf(" +%6.3f, ..%6.3f",wy,ex);
	break;
    case 'v':			/* variance of column sums 		*/
	avva(&cave,&csig,cvec,&tmat);
	videocursor(0,23,0); printf("av%6.3f, va%6.3f",cave,csig);
	break;
    case 'w':
      videoscroll(1,0,24,39,0,0);
      videocursor(0,1,0);
      if (ss==0) {printf("S required first"); break;}
      printf("       min,    ave,    max,  nominal\n");
        for (i0=0; i0<K3+1; i0++)
	  {f=sta[0][i0]; if (f>0.0) {
	  e=sta[1][i0]/f;
          g=sta[3][i0];
          h=sta[4][i0];
	  ff=((double)(i0*i0+(K3-i0)*(K3-i0)))/kk4;
          printf("%1u%1u  %6.3f, %6.3f, %6.3f, (%6.3f)\n",K3-i0,i0,g,e,h,ff);
          }}
      break;
    case 'A':
	l++;
	mmat(&hmat,&amat,&gmat);
	cymat(&gmat,&hmat);
	pmat(&gmat,8,5);
	t=tsum(&gmat);
	s=nzel(&gmat);
	videocursor(0,14,0); printf("%4u (%2u) %5u",t,s,l);
	break;
    case 'B':
	l++;
	mmat(&hmat,&bmat,&gmat);
	cymat(&gmat,&hmat);
	pmat(&gmat,8,5);
	t=tsum(&gmat);
	s=nzel(&gmat);
	videocursor(0,14,0); printf("%4u (%2u) %5u",t,s,l);
	break;
    case 'Q':
	l*=2;
	mmat(&hmat,&gmat,&gmat);
	cymat(&gmat,&hmat);
	pmat(&gmat,8,5);
	t=tsum(&gmat);
	s=nzel(&gmat);
	videocursor(0,14,0); printf("%4u (%2u) %5u",t,s,l);
	break;
    case 'S':
      for (i0=0; i0<5; i0++) for (i1=0; i1<K3+1; i1++) sta[i0][i1]=0.0;
      for (i1=0; i1<K3+1; i1++) sta[3][i1]=10.0;
      stt=0.0;
      allmo(&stt,sta);
      ss=1;
      break;
    case 'T':
	ll++;
	mmmat(&vmat,&tmat,&umat);
	umat=vmat;
	ppmat(&umat,5,21);
	qqmat(&umat,150,50);
	t=ttsum(&umat);
	s=nnzel(&umat);
	ff=f; f=(double)t;
	h=h*kay;
	gg=g; g=f/h;
	videocursor(0,22,18); printf("%7u [%3u]%6.3f  ",t,s,f/ff);
	videocursor(0,23,20); printf("m[2] ratio:%6.3f ",sqrt(f/ff));
	gr=g/gg; gl=0.0; if (gr>0.0) gl=log(gr);
	go=g*exp(-((double)(ll-1))*gl);
	videocursor(0,24,20); printf("%5.3f exp(%6.3fn)",sqrt(go),0.5*gl);
	tt=1;
	break;
    case 'X':
	l+=m;
	mmat(&hmat,&xmat,&gmat);
	cymat(&gmat,&hmat);
	pmat(&gmat,8,5);
	t=tsum(&gmat);
	s=nzel(&gmat);
	videocursor(0,14,0); printf("%4u (%2u) %5u",t,s,l);
	break;
    case '=': m=l; cymat(&xmat,&gmat); break;
    case '/': videoscroll(1,0,24,39,0,0); break;
    case '.':
	videoscroll(1,0,24,39,0,0);
	pmat(&amat,1,0);
	pmat(&bmat,1,10);
	videocursor(0,16,2); printf("a=%1u",t0);
	videocursor(0,16,8); printf("b=%1u",t1);
	pmat(&gmat,8,5);
	break;
    case '?': clard(); break;

    default: break;
    } /* end switch */
  }   /* end while  */
  videopalette(WHCYMAG);
  videomode(T80X25);
}

/* calculate the first two moments of all rules */
void allmo() {
// int ig, ih, hg[301];
int i, i0, i1, i2, i3, i4, i5, i6, i7;
int t0, t1;
double f, g, ff;
//  i=0;
//  videoscroll(1,0,24,39,0,0);
//  for (i0=0;  i0<301; i0++)   hg[i0]=0;
//  for (i0=10; i0<360; i0+=50) videodot( 99,i0,1);
//  for (i0=10; i0<360; i0+=50) videodot(199,i0,1);
  for (i0=0; i0<KK; i0++) {binrule[0][0][0]=i0;
  for (i1=0; i1<KK; i1++) {binrule[0][0][1]=i1;
  for (i2=0; i2<KK; i2++) {binrule[0][1][0]=i2;
  for (i3=0; i3<KK; i3++) {binrule[0][1][1]=i3;
  for (i4=0; i4<KK; i4++) {binrule[1][0][0]=i4;
  for (i5=0; i5<KK; i5++) {binrule[1][0][1]=i5;
  for (i6=0; i6<KK; i6++) {binrule[1][1][0]=i6;
  for (i7=0; i7<KK; i7++) {binrule[1][1][1]=i7;
    zmat(&amat);  djmat(&amat,0);
    zmat(&bmat);  djmat(&bmat,1);
    zzmat(&tmat); tensq(&tmat,&amat,&bmat);
    t0=tsum(&amat);
    t1=tsum(&bmat);
    if (t0<=t1)
      {
      mmmat(&vmat,&tmat,&tmat);
      mmmat(&umat,&tmat,&vmat);
      mmmat(&vmat,&tmat,&umat);
      ff=(double)ttsum(&umat);
      f= (double)ttsum(&vmat);
      g=f/ff;
//      ig=(int)(300.0*((g-2.0)/(4.0-2.0)));
//      hg[ig]++;
//      ih=hg[ig]; if (ih>100) ih=100+ih/10;
//      videodot(ih,10+ig,2);
      sta[0][t0]+=1.0;
      sta[1][t0]+=g; sta[2][t0]+=g*g;
      if (sta[3][t0]>=g) sta[3][t0]=g;
      if (sta[4][t0]<=g) sta[4][t0]=g;
      if (g==2.0) stt+=1.0;
      }
//    i++;
    }}}}}}}}
}

/* calculate tensor square axa+bxb */
void tensq(tmat,amat,bmat) twoparn *tmat; parneih *amat, *bmat; {
int i0, i1, i2, i3;
for (i0=0; i0<K2; i0++)
for (i1=0; i1<K2; i1++)
for (i2=0; i2<K2; i2++)
for (i3=0; i3<K2; i3++)
  tmat->four[i0][i1][i2][i3]+=
	amat->two[i0][i2]*amat->two[i1][i3]+
	bmat->two[i0][i2]*bmat->two[i1][i3];
}

/* calculate tensor square axaxa+bxbxb */
void tencu(cumat,amat,bmat) thrparn *cumat; parneih *amat, *bmat; {
int i0, i1, i2, i3, i4, i5;
for (i0=0; i0<K2; i0++)
for (i1=0; i1<K2; i1++)
for (i2=0; i2<K2; i2++)
for (i3=0; i3<K2; i3++)
for (i4=0; i4<K2; i4++)
for (i5=0; i5<K2; i5++)
  cumat->six[i0][i1][i2][i3][i4][i5]+=
	amat->two[i0][i3]*amat->two[i1][i4]*amat->two[i2][i5]+
	bmat->two[i0][i3]*bmat->two[i1][i4]*bmat->two[i2][i5];
}

/* coefficients of characteristic equation */
void cheq(k,z) double k[4][2]; int z[KK][KK]; {
int t, p, d;
t=z[0][0]+z[1][1]+z[2][2];
p=z[0][0]*z[1][1]-z[0][1]*z[1][0];
p+=z[1][1]*z[2][2]-z[1][2]*z[2][1];
p+=z[2][2]*z[0][0]-z[2][0]*z[0][2];
d=z[0][0]*(z[1][1]*z[2][2]-z[1][2]*z[2][1]);
d+=z[0][1]*(z[1][2]*z[2][0]-z[1][0]*z[2][2]);
d+=z[0][2]*(z[2][1]*z[1][0]-z[1][1]*z[2][0]);
k[0][0]= 1.0;       k[0][1]=0.0;
k[1][0]=-(double)t; k[1][1]=0.0;
k[2][0]= (double)p; k[2][1]=0.0;
k[3][0]=-(double)d; k[3][1]=0.0;
}

void clard() {
  videomode(COLGRAF);
  videopalette(YELREGR);
  videocursor(0,0,0);
  scrrul();
  woruno(0,22);
  videocursor(0,3,0);
  printf("counterimages\n\n");
  printf("ab  - 0,1 matrix\n");
  printf("AB  - times abc \n");
  printf("=Xx - saved mtrx\n");
  printf("Tt  - tensor sq \n");
  printf("Q   - square    \n");
  printf("Ll  - eigenvalue\n");
  printf("h   - histogram \n");
  printf("j   - ancestors \n");
  printf("Ssw - all rules \n");
  printf("                \n");
  printf("?/   - hlp clr  \n");
  printf("<cr> - exit\n\n");
}


void rvers(amat,bmat) parneih *amat, *bmat; {
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m3[KK][KK][KK];
parneih    xmat;
int    i0, i1, i2, i3, i4, i5;
int    t1[KK], t2[KK][KK], t3[KK][KK][KK], t4[KK][KK][KK][KK];
int    t5[KK][KK][KK][KK][KK], t6[KK][KK][KK][KK][KK][KK];
double s, t, u, kk1, kk2, kk3, kk4, kk5, kk6;

kk1=(double)KK;
kk2=(double)K2;
kk3=(double)K3;
kk4=(double)K4;
kk5=(double)K5;
kk6=(double)K6;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0],amat);
cymat(&m1[1],bmat);
t1[0]=tsum(&m1[0]);
t1[1]=tsum(&m1[1]);
videocursor(0,2,0); printf("%3u,%3u",t1[0],t1[1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);
  t2[i0][i1]=tsum(&m2[i0][i1]);
  }
videocursor(0,4,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  printf("%3u,",t2[i0][i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  mmat(&m3[i0][i1][i2],&m1[i0],&m2[i1][i2]);
  t3[i0][i1][i2]=tsum(&m3[i0][i1][i2]);
  }
videocursor(0,6,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  printf("%3u,",t3[i0][i1][i2]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  mmat(&xmat,&m2[i0][i1],&m2[i2][i3]);
  t4[i0][i1][i2][i3]=tsum(&xmat);
  }
videocursor(0,8,0);
for (i0=0; i0<KK; i0++)
  {
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%3u,",t4[i0][i1][i2][i3]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {
  mmat(&xmat,&m2[i0][i1],&m3[i2][i3][i4]);
  t5[i0][i1][i2][i3][i4]=tsum(&xmat);
  }
videocursor(0,11,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
    printf("%3u,",t5[i0][i1][i2][i3][i4]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {
  mmat(&xmat,&m3[i0][i1][i2],&m3[i3][i4][i5]);
  t6[i0][i1][i2][i3][i4][i5]=tsum(&xmat);
  }
videocursor(0,16,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++)
    printf("%3u,",t6[i0][i1][i2][i3][i4][i5]);
  printf("\n");
  }

for (i0=0,s=0.0; i0<KK; i0++) {t=((double)(t1[i0]-AV)); s+=t*t;}
t=sqrt(s/kk1);
videocursor(0,2,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {t=((double)(t2[i0][i1]-AV)); s+=t*t;}
t=sqrt(s/kk2);
videocursor(0,4,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {t=((double)(t3[i0][i1][i2]-AV)); s+=t*t;}
t=sqrt(s/kk3);
videocursor(0,6,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {t=((double)(t4[i0][i1][i2][i3]-AV)); s+=t*t;}
t=sqrt(s/kk4);
videocursor(0,9,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {t=((double)(t5[i0][i1][i2][i3][i4]-AV)); s+=t*t;}
t=u=sqrt(s/kk5);
videocursor(0,14,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {t=((double)(t6[i0][i1][i2][i3][i4][i5]-AV)); s+=t*t;}
t=sqrt(s/kk6);
videocursor(0,23,33); printf("%6.2f",t);

s=1.0; if (u!=0.0) s=t/u;
videocursor(0,24,0); printf("ratio: %6.2f",s);

}

void histo(amat,bmat) parneih *amat, *bmat; {
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m4[KK][KK][KK][KK];
int    i, i0, i1, i2, i3, i4, i5, i6, i7;
int    t8[KK][KK][KK][KK][KK][KK][KK][KK];
int    po, da, h8[AV*K8+1];
char   c[30];
double s, t, kk8;

kk8=(double)K8;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0],amat);
cymat(&m1[1],bmat);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  mmat(&m4[i0][i1][i2][i3],&m2[i0][i1],&m2[i2][i3]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {
  mmat(&xmat,&m4[i0][i1][i2][i3],&m4[i4][i5][i6][i7]);
  t8[i0][i1][i2][i3][i4][i5][i6][i7]=tsum(&xmat);
  }

for (i0=0; i0<AV*K8+1; i0++) h8[i0]=0;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  h8[t8[i0][i1][i2][i3][i4][i5][i6][i7]]++;

po=da=0;
for (i=0; i<60; i++)
  {
  i0=i%20;
  i1=i/20;
  po+=h8[i];
  da+=i*h8[i];
//  videocursor(0,i0+1,13*i1+1);
  sprintf(c,"%2u %4u %4u",i,h8[i],po);
  }

videocursor(0,22,0);  printf("total: %3u in %3u pts;",AV*K8,K8);
videocursor(0,23,0);  printf("average: %2u",AV);
videocursor(0,22,23); printf("beyond: %3u, %3u",AV*K8-da,K8-po);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {t=((double)(t8[i0][i1][i2][i3][i4][i5][i6][i7]-AV)); s+=t*t;}
t=sqrt(s/kk8);
videocursor(0,23,24); printf("sigma:   %6.2f",t);

}

/* search for the reversed rule */
void rever() {
int revrule[KK][KK][KK];
int i0,i1,i2;
  videocursor(0,17,0); printf(".");
  if (runiq(binrule,revrule)) {
    videocursor(0,17,0);
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
      printf("%1d",revrule[i0][i1][i2]);
    printf("\n");
    }
  videocursor(0,18,0); printf(".");
  if (suniq(binrule)) {
    videocursor(0,18,0);
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
      printf("%1d",binrule[i0][i1][i2]);
    printf("\n");
    }
  videocursor(0,19,0); printf(".");
  if (tuniq(binrule)) {
    videocursor(0,19,0);
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
      printf("%1d",binrule[i0][i1][i2]);
    printf("\n");
    }
}

int runiq(brul,rrul) 
int brul[KK][KK][KK], rrul[KK][KK][KK]; {
int a, b, d;
int j0, j1, j2, j3, j4;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
  rrul[j0][j1][j2]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
  {
  a=brul[j0][j1][j2];
  b=brul[j1][j2][j3];
  d=brul[j2][j3][j4];
  if (rrul[a][b][d]==KK) rrul[a][b][d]=j2;
  if (rrul[a][b][d]!=j2) return(0);
  }
return(1);
}

int suniq(brul) int brul[KK][KK][KK]; {
int a, b, e, f, g, c[KK][KK][KK][KK][KK];
int j0, j1, j2, j3, j4, j5, j6;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
  c[j0][j1][j2][j3][j4]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
  {
  a=brul[j0][j1][j2];
  b=brul[j1][j2][j3];
  e=brul[j2][j3][j4];
  f=brul[j3][j4][j5];
  g=brul[j4][j5][j6];
  if (c[a][b][e][f][g]==KK) c[a][b][e][f][g]=j3;
  if (c[a][b][e][f][g]!=j3) return(0);
  }
return(1);
}

int tuniq(brul) int brul[KK][KK][KK]; {
int a, b, e, f, g, h, i, c[KK][KK][KK][KK][KK][KK][KK];
int j0, j1, j2, j3, j4, j5, j6, j7, j8;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
  c[j0][j1][j2][j3][j4][j5][j6]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
for (j7=0; j7<KK; j7++)
for (j8=0; j8<KK; j8++)
  {
  a=brul[j0][j1][j2];
  b=brul[j1][j2][j3];
  e=brul[j2][j3][j4];
  f=brul[j3][j4][j5];
  g=brul[j4][j5][j6];
  h=brul[j5][j6][j7];
  i=brul[j6][j7][j8];
  if (c[a][b][e][f][g][h][i]==KK) c[a][b][e][f][g][h][i]=j4;
  if (c[a][b][e][f][g][h][i]!=j4) return(0);
  }
return(1);
}

/* print matrix */
void pmat(z,i,j) parneih *z; int i, j; {
int i0, i1, i2, i3;
videocursor(0,1,0);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    {
    videocursor(0,i+i0*KK+i1,j);
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
      printf("%1d",z->four[i0][i1][i2][i3]);
    }
}


/* display K4xK4 matrix */
void ppmat(z,i,j) twoparn *z; int i, j; {
int i0, i1;
for (i0=0; i0<K4; i0++)
for (i1=0; i1<K4; i1++)
  {videocursor(0,i+i0,j+i1); printf("%1d",z->two[i0][i1]);}
}


/* display K4xK4 matrix */
void qqmat(z,i,j) twoparn *z; int i, j; {
int i0, i1, k, l;
for (i0=0; i0<K4; i0++)
for (i1=0; i1<K4; i1++)
  {
  k=0; l=z->two[i0][i1];
  if (l==1) k=1;
  if (l>=2) k=2;
  if (l>=4) k=3;
  videodot(i+i0,j+i1,k);
  }
}


/* total matrix elements */
unsigned int tsum(z) parneih *z; {int t, i;
for (i=t=0; i<K4; i++) t+=z->one[i]; return t;}


/* total matrix elements */
unsigned int ttsum(z) twoparn *z; {int t, i;
for (i=t=0; i<K4*K4; i++) t+=z->one[i]; return t;}


/* count nonzero matrix elements */
unsigned int nzel(z) parneih *z; {int t, i;
for (i=t=0; i<K2*K2; i++) if (z->one[i]!=0) t++; return t;}

/* count nonzero matrix elements */
unsigned int nnzel(z) twoparn *z; {int t, i;
for (i=t=0; i<K4*K4; i++) if (z->one[i]!=0) t++; return t;}

/* calculate row sums */
void rowsum(x,z) int x[KK][KK]; parneih *z; {int i0, i1, j0, j1;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
  x[i0][i1]=0;
  for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) 
	x[i0][i1]+=z->four[i0][i1][j0][j1];
  }
}

/* calculate column sums */
void colsum(x,z) int x[KK][KK]; parneih *z; {int i0, i1, j0, j1;
for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) {
  x[j0][j1]=0;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
	x[j0][j1]+=z->four[i0][i1][j0][j1];
  }
}


/* copy one K2xK2 matrix from another: z=x */
void cymat(z,x) parneih *z, *x; {int i; 
for (i=0; i<K2*K2; i++) z->one[i]=x->one[i];}


/* copy one K4xK4 matrix from another: z=x */
void ccymat(z,x) twoparn *z, *x; {int i;
  for (i=0; i<K4*K4; i++) z->one[i]=x->one[i];}


/* multiply K2xK2 matrices*/ 
void mmat(z,x,y) parneih *z, *x, *y;
{
int i0, i1, i2;
  for (i0=0; i0<K2; i0++)
  for (i2=0; i2<K2; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<K2; i1++) z->two[i0][i2]+=x->two[i0][i1]*y->two[i1][i2];
      }
}


/* multiply K4xK4 matrices */
void mmmat(z,x,y) twoparn *z, *x, *y; {
int i0, i1, i2;
  for (i0=0; i0<K4; i0++)
  for (i2=0; i2<K4; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<K4; i1++) z->two[i0][i2]+=x->two[i0][i1]*y->two[i1][i2];
      }
}

/* multiply K4xK4*K4 matrices */
void mmmmat(z,x,y) thrparn *z, *x, *y; {
int i0, i1, i2;
  for (i0=0; i0<K6; i0++)
  for (i2=0; i2<K6; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<K4; i1++) z->two[i0][i2]+=x->two[i0][i1]*y->two[i1][i2];
      }
}


/* generate the de Bruijn fragment evolving to l in matrix z */
void djmat(z,l) parneih *z; int l; {
int i0, i1, i2;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
    z->four[i0][i1][i1][i2]=(binrule[i0][i1][i2]==l)?1:0;
}

/* generate a K4xK4 unit matrix */
void unmat(z) twoparn *z; 
{int i; zzmat(z); for (i=0; i<K4; i++) z->two[i][i]=1;}

/* generate a K4xK4xK4 unit matrix */
void unimat(z) thrparn *z; 
{int i; zzzmat(z); for (i=0; i<K6; i++) z->two[i][i]=1;}


/* zero a K2xK2 matrix */
void zmat(z) parneih *z; {int i; for (i=0; i<K4; i++) z->one[i]=0;}
          
/* zero a K4xK4 matrix */
void zzmat(z) twoparn *z; {int i; for (i=0; i<K4*K4; i++) z->one[i]=0;}

/* zero a K4xK4xK4 matrix */
void zzzmat(z) thrparn *z; {int i; for (i=0; i<K4*K4*K4; i++) z->one[i]=0;}

/* average and variance of eigenvector components */
/* supposes that a valid cve already exists	  */

void auua(ave,var,ex,wy,cve,vec,mat)
 double *ave, *var, *ex, *wy, *cve, *vec;
 twoparn *mat; {
int    i, j;
double a, v, p, q, r, kk4;
kk4=(double)K4;
for (i=0; i<K4; i++)
for (vec[i]=0.0, j=0; j<K4; j++)
  vec[i]+=(double)mat->two[j][i];
for (a=0.0, i=0; i<K4; i++) a+=vec[i];
for (i=0; i<K4; i++) vec[i]/=a;
a=1.0/kk4;
for (i=0; i<K4; i++) vec[i]-=a;
for (v=0.0, i=0; i<K4; i++) v+=vec[i]*vec[i];
for (p=q=r=0.0, i=0; i<K4; i++)
  {
  p+=cve[i]*vec[i];
  q+=cve[i]*cve[i];
  r+=vec[i]*vec[i];
  }
*ave=a;
*var=sqrt(v/kk4);
*ex=0.0; if(q*r>0.0) *ex=p/sqrt(q*r);
*wy=p;
}

/* average and variance of column sums */

void avva(ave,var,vec,mat) double *ave, *var, *vec; twoparn *mat; {
int    i, j;
double a, v, kk4;
kk4=(double)K4;
for (i=0; i<K4; i++)
for (vec[i]=0.0, j=0; j<K4; j++)
  vec[i]+=(double)mat->two[i][j];
for (a=0.0, i=0; i<K4; i++) a+=vec[i];
a/=kk4;
for (i=0; i<K4; i++) vec[i]-=a;
for (v=0.0, i=0; i<K4; i++) v+=vec[i]*vec[i];
*ave=a;
*var=sqrt(v/kk4);
}


/* end nxardn21.c */
