
/* nxfour21.c						*/
/* program for lcau21 option 'd'			*/
/* continuation of rijn21.c for period 4 and beyond	*/
/* Harold V. McIntosh, 30 September 1989		*/
/* 30 September 1989 - split rijn21.c, include five21.c	*/
/* 2 October 1989 - include six21.c for period 6	*/

/*	Copyright (C) 1987	*/
/*	Copyright (C) 1988	*/
/*	Copyright (C) 1989	*/
/*	Copyright (C) 1994	*/
/*	Harold V. McIntosh	*/

# include <math.h>
# include "nxlcau21.h"

extern char arr1[AL];
extern char                   ascrule[KK][KK][KK];
extern int                    binrule[KK][KK][KK];
extern char         darry[KK][KK][KK][KK][KK][KK][KK][KK][KK];
extern char     earry[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
extern char farry[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
extern char dbtag[DDN];			/* tag the nucleus */
extern int  dd;				/* # points in de Bruijn ring	*/

void dpass1(int l);
void dpass2i();
void dpass2o();
int  dpass3();
void dpass4();
void dprf(int i0, int i1, int i2, int i3, int i4, int i5, int i6, int i7, int i8);
void dpass5(int c);
void dpass6();

void epass1(int l);
void epass2i();
void epass2o();
int  epass3();
void epass4();
void eprf(int i0, int i1, int i2, int i3, int i4, int i5, int i6, int i7, int i8, int i9, int i10);
void epass5(int c);
void epass6();

void fpass1(int l);
void fpass2i();
void fpass2o();
int  fpass3();
void fpass4();
void fprf(int i0, int i1, int i2, int i3, int i4, int i5, int i6, int i7, int i8, int i9, int i10, int i11, int i12);
void fpass5(int c);
void fpass6();
extern void asctobin();

/* FOUR21.C */

/* mark sequences conforming to (-4+l,4) */
void dpass1(l) int l; {
int ix[4*RR-3], jx[3*RR-2], kx[2*RR-1], lx[RR], mx;
int i, m=0, n=0;
asctobin();
// printf(" Pass1 \015");
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++)
for (ix[3]=0; ix[3]<KK; ix[3]++)
for (ix[4]=0; ix[4]<KK; ix[4]++)
for (ix[5]=0; ix[5]<KK; ix[5]++)
for (ix[6]=0; ix[6]<KK; ix[6]++)
for (ix[7]=0; ix[7]<KK; ix[7]++)
for (ix[8]=0; ix[8]<KK; ix[8]++) {
  for (i=0; i<7; i++) jx[i]=binrule[ix[i]][ix[i+1]][ix[i+2]];
  for (i=0; i<5; i++) kx[i]=binrule[jx[i]][jx[i+1]][jx[i+2]];
  for (i=0; i<3; i++) lx[i]=binrule[kx[i]][kx[i+1]][kx[i+2]];
  mx=binrule[lx[0]][lx[1]][lx[2]];
  if (l<9)   {m=ix[l]; n=mx;}
    else if (l==9)  {m=ix[0]; n=lx[1];}
    else if (l==10) {m=ix[8]; n=lx[1];}
    else if (l==11) {m=ix[0]; n=kx[2];}
    else if (l==12) {m=ix[8]; n=kx[2];}
    else if (l==13) {m=ix[0]; n=jx[3];}
    else if (l==14) {m=ix[8]; n=jx[3];}
    else if (l==15) {m=0; n=mx;}
    else if (l==16) {m=1; n=mx;}
darry[ix[0]][ix[1]][ix[2]][ix[3]][ix[4]][ix[5]][ix[6]][ix[7]][ix[8]]=m==n?'Y':'N';
}
dpass2i();
dpass2o();
// edshf(arry,ix,9,dpass4,dpass5);
}

/* mark sequences conforming to (-4+l,4) */
void wpass1(l) int l; {
int ix[4*RR-3], jx[3*RR-2], kx[2*RR-1], lx[RR], mx;
int i, m=0, n=0;
asctobin();
// printf(" Pass1 \015");
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++)
for (ix[3]=0; ix[3]<KK; ix[3]++)
for (ix[4]=0; ix[4]<KK; ix[4]++)
for (ix[5]=0; ix[5]<KK; ix[5]++)
for (ix[6]=0; ix[6]<KK; ix[6]++)
for (ix[7]=0; ix[7]<KK; ix[7]++)
for (ix[8]=0; ix[8]<KK; ix[8]++) {
  for (i=0; i<7; i++) jx[i]=binrule[ix[i]][ix[i+1]][ix[i+2]];
  for (i=0; i<5; i++) kx[i]=binrule[jx[i]][jx[i+1]][jx[i+2]];
  for (i=0; i<3; i++) lx[i]=binrule[kx[i]][kx[i+1]][kx[i+2]];
  mx=binrule[lx[0]][lx[1]][lx[2]];
darry[ix[0]][ix[1]][ix[2]][ix[3]][ix[4]][ix[5]][ix[6]][ix[7]][ix[8]]=mx==l?'Y':'N';
}
dpass2i();
dpass2o();
}

/* Pass 2i flags links which have an incoming arrow */
void dpass2i() {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, m;
do {
// printf(" pass2i\015");
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++) {
if ((darry[i0][i1][i2][i3][i4][i5][i6][i7][i8]&0x5F)=='Y')
 {for (m=0; m<KK; m++) darry[i1][i2][i3][i4][i5][i6][i7][i8][m]|=0x20;}
}
} while (dpass3()!=0); }

/* Pass 2o flags links which have an outgoing arrow */
void dpass2o() {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, m;
do {
// printf(" pass2o\015");
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++) {
if ((darry[i0][i1][i2][i3][i4][i5][i6][i7][i8]&0x5F)=='Y')
 {for (m=0; m<KK; m++) darry[m][i0][i1][i2][i3][i4][i5][i6][i7]|=0x20;}
}
} while (dpass3()!=0); }

/* erase flags, mark survivors, count channges */
int dpass3() {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, l;
l=0;
// printf(" pass3 \015");
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++) {
switch (darry[i0][i1][i2][i3][i4][i5][i6][i7][i8]) {
    case 'y': darry[i0][i1][i2][i3][i4][i5][i6][i7][i8]='Y'; break;
    case 'Y': darry[i0][i1][i2][i3][i4][i5][i6][i7][i8]='N'; l=1; break;
    case 'n': case 'N': darry[i0][i1][i2][i3][i4][i5][i6][i7][i8]='N'; break;
    default: break; }
}
return l; }

/* Pass4 - print loops which remain */
void dpass4() {
int i0, i1, i2, i3, i4, i5, i6, i7, i8;
int j0, j1, j2, j3, j4, j5, j6, j7, j8;
int k=0, l, m;
// printf(" pass4 \015");
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++) {
j0=i0; j1=i1; j2=i2; j3=i3; j4=i4; j5=i5; j6=i6; j7=i7; j8=i8;
l=0;
m=0;
do {
        if (darry[0][j1][j2][j3][j4][j5][j6][j7][j8]=='Y')
    {darry[0][j1][j2][j3][j4][j5][j6][j7][j8]='y';
    k=j8; j8=j7; j7=j6; j6=j5; j5=j4; j4=j3; j3=j2; j2=j1; j1=0; m=1;}
  else {if (darry[1][j1][j2][j3][j4][j5][j6][j7][j8]=='Y')
    {darry[1][j1][j2][j3][j4][j5][j6][j7][j8]='y';
    k=j8; j8=j7; j7=j6; j6=j5; j5=j4; j4=j3; j3=j2; j2=j1; j1=1; m=1;}
  else {l=1;
    if (m==1) {j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=j8; j8=k;}
    }}
  } while (l==0);
l=0; 
m=0;
do {
        if (darry[j0][j1][j2][j3][j4][j5][j6][j7][0]=='y')
   {dprf(j0,j1,j2,j3,j4,j5,j6,j7,0);
   darry[j0][j1][j2][j3][j4][j5][j6][j7][0]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=0; m=1;}
  else {if (darry[j0][j1][j2][j3][j4][j5][j6][j7][1]=='y')
   {dprf(j0,j1,j2,j3,j4,j5,j6,j7,1);
   darry[j0][j1][j2][j3][j4][j5][j6][j7][1]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=1; m=1;}
  else {l=1;}}
  } while (l==0);
l=0;
do {
        if (darry[j0][j1][j2][j3][j4][j5][j6][j7][0]=='Y')
   {dprf(j0,j1,j2,j3,j4,j5,j6,j7,0);
   darry[j0][j1][j2][j3][j4][j5][j6][j7][0]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=0; m=1;}
  else {if (darry[j0][j1][j2][j3][j4][j5][j6][j7][1]=='Y')
   {dprf(j0,j1,j2,j3,j4,j5,j6,j7,1);
   darry[j0][j1][j2][j3][j4][j5][j6][j7][1]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=1; m=1;}
  else {l=1;}}
  } while (l==0);
}
}

/* print one of the individual links in a chain */
void dprf(i0,i1,i2,i3,i4,i5,i6,i7,i8)
int i0, i1, i2, i3, i4, i5, i6, i7, i8; {
int i, j;
// printf("%1d",i0);
// printf("%1d",i1);
// printf("%1d",i2);
// printf("%1d",i3);
// printf("%1d",i4);
// printf("%1d",i5);
// printf("%1d",i6);
// printf("%1d",i7);
// printf("-");
// printf("%1d",i8);
// printf(" ");
i=((((((i0*KK+i1)*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7;
j=((((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8;
lijnk(i,j,3);
}

/* Pass 5 - show evolution of sample loops */
void dpass5(c) char c; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8;
int j1, j2, j3, j4, j5, j6, j7;
int b[KK], irry[4*RR-3], i, j, k, l;
int hl;
  switch (c) {
    case 'z': zerix(irry,9); break;
    case 'r': ranix(irry,9); break;
    case 'n': nodix(irry,9); break;
    case 'i': incix(irry,9); break;
    default:  zerix(irry,9); break;}
  i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3];
  i4=irry[4]; i5=irry[5]; i6=irry[6]; i7=irry[7]; i8=irry[8];
for (k=0; k<512; k++) {
  if (darry[i0][i1][i2][i3][i4][i5][i6][i7][i8]=='Y') break;
  incix(irry,9);
    i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3];
    i4=irry[4]; i5=irry[5]; i6=irry[6]; i7=irry[7]; i8=irry[8];
  }
hl=AL/2;
arr1[hl-4]=i0;
arr1[hl-3]=i1;
arr1[hl-2]=i2;
arr1[hl-1]=i3;
arr1[hl  ]=i4;
arr1[hl+1]=i5;
arr1[hl+2]=i6;
arr1[hl+3]=i7;
arr1[hl+4]=i8;
j1=i1; j2=i2; j3=i3; j4=i4; j5=i5; j6=i6; j7=i7;
for (k=hl-5; k>=0; k--) {
  for (i=j=0; j<KK; j++)
    if (darry[j][i0][i1][i2][i3][i4][i5][i6][i7]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=((int)random())%i;
  i7=i6; i6=i5; i5=i4; i4=i3; i3=i2; i2=i1; i1=i0; i0=arr1[k]=b[l];
  }
i1=j1; i2=j2; i3=j3; i4=j4; i5=j5; i6=j6; i7=j7;
for (k=hl+5; k<AL; k++) {
  for (i=j=0; j<KK; j++)
    if (darry[i1][i2][i3][i4][i5][i6][i7][i8][j]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=((int)random())%i;
// n0=((((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8;
  i1=i2; i2=i3; i3=i4; i4=i5; i5=i6; i6=i7; i7=i8; i8=arr1[k]=b[l];
// n1=((((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8;
// printf("%3d, %3d, %3d\n",n0,n1,i);
  }
}

void dpass6() {int i, j, i0, i1, i2, i3, i4, i5, i6, i7, i8;
for (i=0; i<DDN; i++) dbtag[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++) {
  i=((((((i0*KK+i1)*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7;
  j=((((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8;
  if(darry[i0][i1][i2][i3][i4][i5][i6][i7][i8]=='Y') {
	dbtag[i]=1;
	dbtag[j]=1;
	lijnk(i,j,3);
	}
  }
}

/* FIVE21.C */
/* arry requires 2048 bytes */

/* mark sequences conforming to (-5+l,5) */
void epass1(l) int l; {
int ix[5*RR-4], jx[4*RR-3], kx[3*RR-2], lx[2*RR-1], mx[RR], nx;
int i, m, n;
asctobin();
// printf(" Pass1 \015");
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++)
for (ix[3]=0; ix[3]<KK; ix[3]++)
for (ix[4]=0; ix[4]<KK; ix[4]++)
for (ix[5]=0; ix[5]<KK; ix[5]++)
for (ix[6]=0; ix[6]<KK; ix[6]++)
for (ix[7]=0; ix[7]<KK; ix[7]++)
for (ix[8]=0; ix[8]<KK; ix[8]++)
for (ix[9]=0; ix[9]<KK; ix[9]++)
for (ix[10]=0; ix[10]<KK; ix[10]++) {
  for (i=0; i<9; i++) jx[i]=binrule[ix[i]][ix[i+1]][ix[i+2]];
  for (i=0; i<7; i++) kx[i]=binrule[jx[i]][jx[i+1]][jx[i+2]];
  for (i=0; i<5; i++) lx[i]=binrule[kx[i]][kx[i+1]][kx[i+2]];
  for (i=0; i<3; i++) mx[i]=binrule[lx[i]][lx[i+1]][lx[i+2]];
  nx=binrule[mx[0]][mx[1]][mx[2]];
if (l<11) {m=ix[l]; n=nx;}
  else if (l==11) {m=ix[0];  n=mx[1];}
  else if (l==12) {m=ix[10]; n=mx[1];}
  else if (l==13) {m=ix[0];  n=lx[2];}
  else if (l==14) {m=ix[10]; n=lx[2];}
  else if (l==15) {m=ix[0];  n=kx[3];}
  else if (l==16) {m=ix[10]; n=kx[3];}
  else if (l==17) {m=ix[0];  n=jx[4];}
  else if (l==18) {m=ix[10]; n=jx[4];}
  else if (l==19) {m=0; n=nx;}
  else if (l==20) {m=1; n=nx;}
earry[ix[0]][ix[1]][ix[2]][ix[3]][ix[4]][ix[5]]
  [ix[6]][ix[7]][ix[8]][ix[9]][ix[10]]=m==n?'Y':'N';
}
epass2i();
epass2o();
// edshf(arry,ix,11,epass4,epass5);
}

/* Pass 2i flags links which have an incoming arrow */
void epass2i() {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, m;
do {
// printf(" pass2i\015");
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (i10=0; i10<KK; i10++) {
if ((earry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]&0x5F)=='Y')
 {for (m=0; m<KK; m++) earry[i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][m]|=0x20;}
}
} while (epass3()!=0); }

/* Pass 2o flags links which have an outgoing arrow */
void epass2o() {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, m;
do {
// printf(" pass2o\015");
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (i10=0; i10<KK; i10++) {
if ((earry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]&0x5F)=='Y')
 {for (m=0; m<KK; m++) earry[m][i0][i1][i2][i3][i4][i5][i6][i7][i8][i9]|=0x20;}
 }
} while (epass3()!=0); }

/* erase flags, mark survivors, count channges */
int epass3() {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, l;
l=0;
// printf(" pass3 \015");
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (i10=0; i10<KK; i10++) {
switch (earry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]) {
    case 'y': earry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]='Y'; break;
    case 'Y': earry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]='N'; l=1; break;
    case 'n': case 'N': earry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]='N'; break;
    default: break; }
}
return l; }

/* Pass4 - print loops which remain */
void epass4() {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10;
int j0, j1, j2, j3, j4, j5, j6, j7, j8, j9, j10;
int k, l, m;
// printf(" pass4 \015");
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (i10=0; i10<KK; i10++) {
j0=i0; j1=i1; j2=i2; j3=i3; j4=i4; j5=i5; j6=i6; j7=i7; j8=i8; j9=i9; j10=i10;
l=0;
m=0;
do {
        if (earry[0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10]=='Y')
    {earry[0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10]='y';
    k=j10; j10=j9; j9=j8; j8=j7; j7=j6;
    j6=j5; j5=j4; j4=j3; j3=j2; j2=j1; j1=0; m=1;}
  else {if (earry[1][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10]=='Y')
    {earry[1][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10]='y';
    k=j10; j10=j9; j9=j8; j8=j7; j7=j6;
    j6=j5; j5=j4; j4=j3; j3=j2; j2=j1; j1=1; m=1;}
  else {l=1;
    if (m==1) {j0=j1; j1=j2; j2=j3; j3=j4;
    j4=j5; j5=j6; j6=j7; j7=j8; j8=j9; j9=j10; j10=k;}
    }}
  } while (l==0);
l=0; 
m=0;
do {
        if (earry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][0]=='y')
   {eprf(j0,j1,j2,j3,j4,j5,j6,j7,j8,j9,0);
   earry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][0]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=j8; j8=j9; j9=0; m=1;}
  else {if (earry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][1]=='y')
   {eprf(j0,j1,j2,j3,j4,j5,j6,j7,j8,j9,1);
   earry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][1]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=j8; j8=j9; j9=1; m=1;}
  else {l=1;}}
  } while (l==0);
l=0;
do {
        if (earry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][0]=='Y')
   {eprf(j0,j1,j2,j3,j4,j5,j6,j7,j8,j9,0);
   earry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][0]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=j8; j8=j9; j9=0; m=1;}
  else {if (earry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][1]=='Y')
   {eprf(j0,j1,j2,j3,j4,j5,j6,j7,j8,j9,1);
   earry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][1]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=j8; j8=j9; j9=1; m=1;}
  else {l=1;}}
  } while (l==0);
}
}

/* print one of the individual links in a chain */
void eprf(i0,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10; {
int i, j;
// printf("%1d",i0);
// printf("%1d",i1);
// printf("%1d",i2);
// printf("%1d",i3);
// printf("%1d",i4);
// printf("%1d",i5);
// printf("%1d",i6);
// printf("%1d",i7);
// printf("%1d",i8);
// printf("%1d",i9);
// printf("-");
// printf("%1d",i10);
// printf(" ");
i=((((((((i0*KK+i1)*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8)*KK+i9;
j=((((((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8)*KK+i9)*KK+i10;
lijnk(i,j,3);
}

/* Pass 5 - show evolution of sample loops */
void epass5(c) char c; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10;
int j1, j2, j3, j4, j5, j6, j7, j8, j9;
int b[KK], irry[5*RR-4], i, j, k, l;
  switch (c) {
    case 'z': zerix(irry,11); break;
    case 'r': ranix(irry,11); break;
    case 'n': nodix(irry,11); break;
    case 'i': incix(irry,11); break;
    default:  zerix(irry,11); break;}
  i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3]; i4=irry[4];
  i5=irry[5]; i6=irry[6]; i7=irry[7]; i8=irry[8]; i9=irry[9];
  i10=irry[10];
for (k=0; k<2048; k++) {
  if (earry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]=='Y') break;
  incix(irry,11);
  i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3]; i4=irry[4];
  i5=irry[5]; i6=irry[6]; i7=irry[7]; i8=irry[8]; i9=irry[9];
  i10=irry[10];
  }
arr1[AL/2-5]=i0;
arr1[AL/2-4]=i1;
arr1[AL/2-3]=i2;
arr1[AL/2-2]=i3;
arr1[AL/2-1]=i4;
arr1[AL/2]=i5;
arr1[AL/2+1]=i6;
arr1[AL/2+2]=i7;
arr1[AL/2+3]=i8;
arr1[AL/2+4]=i9;
arr1[AL/2+5]=i10;
j1=i1; j2=i2; j3=i3; j4=i4; j5=i5; j6=i6; j7=i7, j8=i8, j9=i9;
for (k=AL/2-6; k>=0; k--) {
  for (i=j=0; j<KK; j++)
    if (earry[j][i0][i1][i2][i3][i4][i5][i6][i7][i8][i9]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=((int)random())%i;
  i9=i8; i8=i7; i7=i6; i6=i5; i5=i4;
  i4=i3; i3=i2; i2=i1; i1=i0; i0=arr1[k]=b[l];
  }
i1=j1; i2=j2; i3=j3; i4=j4; i5=j5; i6=j6; i7=j7; i8=j8; i9=j9;
for (k=AL/2+6; k<AL; k++) {
  for (i=j=0; j<KK; j++)
    if (earry[i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][j]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=((int)random())%i;
  i1=i2; i2=i3; i3=i4; i4=i5; i5=i6;
  i6=i7; i7=i8; i8=i9; i9=i10; i10=arr1[k]=b[l];
  }
// videoscroll(EROW,0,EROW+1,40,0,0);
// asctobin();
// for (j=8*EROW; j<8*(EROW+2)-2; j++) videodot(j,AL-1,2);
// for (j=8*EROW; j<8*(EROW+2)-2; j++) {
//   for (i=0; i<AL; i++) videodot(j,i,arr1[i]);
//   onegen(AL);
//   }
}

void epass6() {int i, j, i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10;
for (i=0; i<DDN; i++) dbtag[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (i10=0; i10<KK; i10++) {
  i=((((((((i0*KK+i1)*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8)*KK+i9;
  j=((((((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8)*KK+i9)*KK+i10;
  if(earry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]=='Y') {
	dbtag[i]=1;
	dbtag[j]=1;
	lijnk(i,j,3);
	}
  }
}

/* SIX21.C */
/* farry requires 8192 bytes */

/* mark sequences conforming to (-6+l,6) */
void fpass1(l) int l; {
int ix[6*RR-5], jx[5*RR-4], kx[4*RR-3], lx[3*RR-2], mx[2*RR-1], nx[RR], ox;
int i, m, n;
asctobin();
// printf(" Pass1 \015");
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++)
for (ix[3]=0; ix[3]<KK; ix[3]++)
for (ix[4]=0; ix[4]<KK; ix[4]++)
for (ix[5]=0; ix[5]<KK; ix[5]++)
for (ix[6]=0; ix[6]<KK; ix[6]++)
for (ix[7]=0; ix[7]<KK; ix[7]++)
for (ix[8]=0; ix[8]<KK; ix[8]++)
for (ix[9]=0; ix[9]<KK; ix[9]++)
for (ix[10]=0; ix[10]<KK; ix[10]++)
for (ix[11]=0; ix[11]<KK; ix[11]++)
for (ix[12]=0; ix[12]<KK; ix[12]++) {
  for (i=0; i<11; i++) jx[i]=binrule[ix[i]][ix[i+1]][ix[i+2]];
  for (i=0; i<9; i++) kx[i]=binrule[jx[i]][jx[i+1]][jx[i+2]];
  for (i=0; i<7; i++) lx[i]=binrule[kx[i]][kx[i+1]][kx[i+2]];
  for (i=0; i<5; i++) mx[i]=binrule[lx[i]][lx[i+1]][lx[i+2]];
  for (i=0; i<3; i++) nx[i]=binrule[mx[i]][mx[i+1]][mx[i+2]];
  ox=binrule[nx[0]][nx[1]][nx[2]];
if (l<13) {m=ix[l]; n=ox;}
  else if (l==13) {m=ix[0];  n=nx[1];}
  else if (l==14) {m=ix[12]; n=nx[1];}
  else if (l==15) {m=ix[0];  n=mx[2];}
  else if (l==16) {m=ix[12]; n=mx[2];}
  else if (l==17) {m=ix[0];  n=lx[3];}
  else if (l==18) {m=ix[12]; n=lx[3];}
  else if (l==19) {m=ix[0];  n=kx[4];}
  else if (l==20) {m=ix[12]; n=kx[4];}
  else if (l==21) {m=ix[0];  n=jx[5];}
  else if (l==22) {m=ix[12]; n=jx[5];}
farry[ix[0]][ix[1]][ix[2]][ix[3]][ix[4]][ix[5]][ix[6]]
    [ix[7]][ix[8]][ix[9]][ix[10]][ix[11]][ix[12]]=m==n?'Y':'N';
}
fpass2i();
fpass2o();
}

/* Pass 2i flags links which have an incoming arrow */
void fpass2i() {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, m;
do {
// printf(" pass2i\015");
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (i10=0; i10<KK; i10++)
for (i11=0; i11<KK; i11++)
for (i12=0; i12<KK; i12++) {
if ((farry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11][i12]&0x5F)=='Y')
 {for (m=0; m<KK; m++) farry[i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11][i12][m]|=0x20;}
}
} while (fpass3()!=0); }

/* Pass 2o flags links which have an outgoing arrow */
void fpass2o() {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, m;
do {
// printf(" pass2o\015");
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (i10=0; i10<KK; i10++)
for (i11=0; i11<KK; i11++)
for (i12=0; i12<KK; i12++) {
if ((farry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11][i12]&0x5F)=='Y')
 {for (m=0; m<KK; m++) farry[m][i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11]|=0x20;}
}
} while (fpass3()!=0); }

/* erase flags, mark survivors, count channges */
int fpass3() {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, l;
l=0;
// printf(" pass3 \015");
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (i10=0; i10<KK; i10++)
for (i11=0; i11<KK; i11++)
for (i12=0; i12<KK; i12++) {
switch (farry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11][i12]) {
    case 'y': farry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11][i12]='Y'; break;
    case 'Y': farry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11][i12]='N'; l=1; break;
    case 'n': case 'N': farry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11][i12]='N'; break;
    default: break; }
}
return l; }

/* Pass4 - print loops which remain */
void fpass4() {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12;
int j0, j1, j2, j3, j4, j5, j6, j7, j8, j9, j10, j11, j12;
int k, l, m;
// printf(" pass4 \015");
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (i10=0; i10<KK; i10++)
for (i11=0; i11<KK; i11++)
for (i12=0; i12<KK; i12++) {
j0=i0; j1=i1; j2=i2; j3=i3; j4=i4; j5=i5; j6=i6;
j7=i7; j8=i8; j9=i9; j10=i10; j11=i11; j12=i12;
l=0;
m=0;
do {
        if (farry[0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10][j11][j12]=='Y')
    {farry[0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10][j11][j12]='y';
    k=j12; j12=j11; j11=j10; j10=j9; j9=j8; j8=j7; j7=j6;
    j6=j5; j5=j4; j4=j3; j3=j2; j2=j1; j1=0; m=1;}
  else {if (farry[1][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10][j11][j12]=='Y')
    {farry[1][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10][j11][j12]='y';
    k=j12; j12=j11; j11=j10; j10=j9; j9=j8; j8=j7; j7=j6;
    j6=j5; j5=j4; j4=j3; j3=j2; j2=j1; j1=1; m=1;}
  else {l=1;
    if (m==1) {j0=j1; j1=j2; j2=j3; j3=j4;
    j4=j5; j5=j6; j6=j7; j7=j8; j8=j9; j9=j10; j10=j11; j11=j12; j12=k;}
    }}
  } while (l==0);
l=0; 
m=0;
do {
        if (farry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10][j11][0]=='y')
   {fprf(j0,j1,j2,j3,j4,j5,j6,j7,j8,j9,j10,j11,0);
   farry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10][j11][0]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7;
   j7=j8; j8=j9; j9=j10; j10=j11; j11=0; m=1;}
  else {if (farry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10][j11][1]=='y')
   {fprf(j0,j1,j2,j3,j4,j5,j6,j7,j8,j9,j10,j11,1);
   farry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10][j11][1]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7;
   j7=j8; j8=j9; j9=j10; j10=j11; j11=1; m=1;}
  else {l=1;}}
  } while (l==0);
l=0;
do {
        if (farry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10][j11][0]=='Y')
   {fprf(j0,j1,j2,j3,j4,j5,j6,j7,j8,j9,j10,j11,0);
   farry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10][j11][0]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7;
   j7=j8; j8=j9; j9=j10; j10=j11; j11=0; m=1;}
  else {if (farry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10][j11][1]=='Y')
   {fprf(j0,j1,j2,j3,j4,j5,j6,j7,j8,j9,j10,j11,1);
   farry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10][j11][1]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7;
   j7=j8; j8=j9; j9=j10; j10=j11; j11=1; m=1;}
  else {l=1;}}
  } while (l==0);
}
}

/* print one of the individual links in a chain */
void fprf(i0,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12)
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12; {
int i, j;
// printf("%1d",i0);
// printf("%1d",i1);
// printf("%1d",i2);
// printf("%1d",i3);
// printf("%1d",i4);
// printf("%1d",i5);
// printf("%1d",i6);
// printf("%1d",i7);
// printf("%1d",i8);
// printf("%1d",i9);
// printf("%1d",i10);
// printf("%1d",i11);
// printf("-");
// printf("%1d",i12);
// printf(" ");
i=((((((((((i0*KK+i1)*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8)*KK+i9)*KK+i10)*KK+i11;
j=((((((((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8)*KK+i9)*KK+i10)*KK+i11)*KK+i12;
lijnk(i,j,3);
}

/* Pass 5 - show evolution of sample loops */
void fpass5(c) int  c; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12;
int j1, j2, j3, j4, j5, j6, j7, j8, j9, j10, j11;
int b[KK], irry[6*RR-5], i, j, k, l;
  switch (c) {
    case 'z': zerix(irry,13); break;
    case 'r': ranix(irry,13); break;
    case 'n': nodix(irry,13); break;
    case 'i': incix(irry,13); break;
    default:  zerix(irry,13); break;}
  i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3]; i4=irry[4];
  i5=irry[5]; i6=irry[6]; i7=irry[7]; i8=irry[8]; i9=irry[9];
  i10=irry[10]; i11=irry[11]; i12=irry[12];
for (k=0; k<2048; k++) {
  if (farry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11][i12]=='Y') break;
  incix(irry,13);
  i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3]; i4=irry[4];
  i5=irry[5]; i6=irry[6]; i7=irry[7]; i8=irry[8]; i9=irry[9];
  i10=irry[10]; i11=irry[11]; i12=irry[12];
  }
arr1[AL/2-6]=i0;
arr1[AL/2-5]=i1;
arr1[AL/2-4]=i2;
arr1[AL/2-3]=i3;
arr1[AL/2-2]=i4;
arr1[AL/2-1]=i5;
arr1[AL/2]=i6;
arr1[AL/2+1]=i7;
arr1[AL/2+2]=i8;
arr1[AL/2+3]=i9;
arr1[AL/2+4]=i10;
arr1[AL/2+5]=i11;
arr1[AL/2+6]=i12;
j1=i1; j2=i2; j3=i3; j4=i4; j5=i5; j6=i6; j7=i7, j8=i8, j9=i9; j10=i10; j11=i11;
for (k=AL/2-7; k>=0; k--) {
  for (i=j=0; j<KK; j++)
    if (farry[j][i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=((int)random())%i;
  i11=i10; i10=i9; i9=i8; i8=i7; i7=i6; i6=i5; i5=i4;
  i4=i3; i3=i2; i2=i1; i1=i0; i0=arr1[k]=b[l];
  }
i1=j1; i2=j2; i3=j3; i4=j4; i5=j5; i6=j6; i7=j7; i8=j8; i9=j9; i10=j10; i11=j11;
for (k=AL/2+7; k<AL; k++) {
  for (i=j=0; j<KK; j++)
    if (farry[i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11][i12][j]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=((int)random())%i;
  i1=i2; i2=i3; i3=i4; i4=i5; i5=i6;
  i6=i7; i7=i8; i8=i9; i9=i10; i10=i11; i11=i12; i12=arr1[k]=b[l];
  }
}

void fpass6() {int i, j, i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11,  i12;
for (i=0; i<DDN; i++) dbtag[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++) 
for (i10=0; i10<KK; i10++) 
for (i11=0; i11<KK; i11++) 
for (i12=0; i12<KK; i12++) {
  i=((((((((((i0*KK+i1)*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8)*KK+i9)*KK+i10)*KK+i11;
  j=((((((((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8)*KK+i9)*KK+i10)*KK+i11)*KK+i12;
  if(farry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11][i12]=='Y') {
	dbtag[i]=1;
	dbtag[j]=1;
	lijnk(i,j,3);
	}
  }
}

/* end xnfour21.c */
