
/* nxlcau21.h				*/
/* (2,1) Linear Cellular Automaton	*/
/* 12 May 1989				*/

# define COLGRAF     4  /* graph resolution			*/
# define T80X25      3  /* text resolution			*/
# define WHCYMAG     1  /* color quad for normal screen		*/
# define YELREGR     2  /* alternative color palette 		*/
# define AL        320  /* array length (screen width)		*/
# define SL         40	 /* short array length			*/
# define KK	     2  /* number of states per cell		*/
# define RR	     3  /* length of neighborhood = 2r+1	*/ 
# define BD	    12	/* maximum number Bernstein coeffs	*/ 
# define TS	     4  /* distinct sums w/totalistic rule	*/
# define SS ((RR-1)*(KK-1)+1) 	/* distinct sums w/sttl rule	*/
# define DS  (KK*KK*KK)  /* KK^RR (distinct neighborhoods)	*/
# define DN	     4  /* number of de Bruijn nodes = KK^2r	*/
# define PDN	     16  	/* nodes in pair diagram = KK^4r	*/
# define TDN	     64  	/* nodes in triple diagram = KK^6r	*/
# define SDN	     16  	/* nodes in subset diagram = 2^(KK^2r)	*/
# define DDN      32678  	/* max de Bruijn diagram nodes 		*/
# define CCY         12		/* circumference of max length cycle	*/
# define XCY	   4096		/* max number of cycles = KK^CCY	*/
# define XDB	   8192		/* max size of de Bruijn diagram	*/

# define XAN	     52		/* nominal max number of ancestors/node	*/

# define K2     (KK*KK) 
# define K3     (KK*KK*KK) 
# define K4	(K2*K2)
# define K5	(K2*K3)
# define K6	(K3*K3)
# define K8	(K4*K4)
# define AV	(KK*KK)

# define RSYM		 4	/* number of rule symmetries = 2*k!	*/
# define WNML	         3	/* arry size to hold hex wolfram number */

# define XLEN    128 /* buffer length for rec predefined */
# define NY 8
# define CLEN 300 /* buffer length for rec source */
# define PLEN 900 /* buffer length for rec object */

typedef union birular {
		int one[KK*KK*KK]; 
		int three[KK][KK][KK];
		} birular;
typedef union parneih {
		int one[K4];
		int two[K2][K2];
	 	int four[KK][KK][KK][KK];
		} parneih;
typedef union twoparn {
		int one[K8];
		int two[K4][K4]; 
		int four[K2][K2][K2][K2];
		int eight[KK][KK][KK][KK][KK][KK][KK][KK];
		} twoparn;
typedef union thrparn {
		int one[K6*K6];
		int two[K6][K6]; 
		int six[K2][K2][K2][K2][K2][K2];
		int twelve[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
		} thrparn;


/* end nxlcau21.h */
