
/* nxrijn21.c						*/
/* program for LCA21 option 'd'				*/
/* display de Bruijn diagram - 1st, 2nd, & 3rd gen	*/
/* Harold V. McIntosh, 20 February 1988			*/
/* 21 February 1988 - add j0=i0; to Pass 4's		*/
/* 26 September 1989 - show evolution of periodic conf	*/
/* 2 October 1989 - cycl21.c incorporated into rijn21.c	*/
/* 20 November 1989 - correct loop in kwait		*/
/* 22 June 1994 - adapt to NeXT				*/

/*    Copyright (C) 1987		*/
/*    Copyright (C) 1988		*/
/*    Copyright (C) 1989		*/
/*    Copyright (C) 1994		*/
/*    Harold V. McIntosh		*/

# define JX  0.50  /* x-center, de Bruijn diagram	*/
# define JY  0.50  /* y-center, de Bruijn diagram	*/
# define RI 0.425  /* inner radius, de Bruijn diagram	*/
# define RO 0.475  /* outer radius, de Bruijn diagram	*/

# include <math.h>
# include "nxlcau21.h"
# include "nxrijn21.h"
# import  <dpsclient/psops.h>
# import  <appkit/graphics.h>

extern NXColor colst[KK];

extern char arr1[AL], arr2[AL];
extern char ascrule[KK][KK][KK];		/* ASCII transition values */
extern int  binrule[KK][KK][KK];
extern int  ix0, iy0;				/* origin for pen moves */
int  dbno;					/* node in de Bruijn dgm */

char                      aarry[KK][KK][KK];
char                  barry[KK][KK][KK][KK][KK];
char              carry[KK][KK][KK][KK][KK][KK][KK];
char           darry[KK][KK][KK][KK][KK][KK][KK][KK][KK];
char       earry[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
char   farry[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];

char   dbtag[DDN];				/* tag the nucleus 	    */
int    dd;					/* points in de Bruijn ring */
double dcntr[XDB][2];


/* edit the de Bruijn diagram		*/
/* g = number of generation (0==2nd)	*/
/* s = shift distance (g==0)		*/
void edijn(g,s,p,r) int g, s, p, r; {

   switch(g+'a') {
    case 'A': dd=KK*KK; ijn(dd,KK,2); sijn(0,1); break;
    case 'B': dd=KK*KK; ijn(dd,KK,2); sijn(1,1); break;
    case 'C': dd=KK*KK; ijn(dd,KK,2); zijn(dd,0,1); break;
    case 'D': dd=KK*KK; ijn(dd,KK,2); zijn(dd,1,1); break;
    case 'E': dd=KK*KK; ijn(dd,KK,2); zijn(dd,2,1); break;

    case 'G': xpass1(s); break;
    case 'H': ypass1(s); break;
    case 'I': zpass1(s); break;
    case 'J': wpass1(s); break;

    case 'a': switch (s+'g') {
      case 'a': fpass1(21); break;
      case 'b': epass1(17); break;
      case 'c': dpass1(13); break;
      case 'd': cpass1(9,p,r); break;
      case 'e': bpass1(5,p,r); break;
      case 'f': apass1(0,p,r); break;
      case 'g': apass1(1,p,r); break;
      case 'h': apass1(2,p,r); break;
      case 'i': bpass1(6,p,r); break;
      case 'j': cpass1(10,p,r); break;
      case 'k': dpass1(14); break;
      case 'l': epass1(18); break;
      case 'm': fpass1(22); break;
    default: break;} break;

    case 'b': switch (s+'g') {
      case 'a': fpass1(19); break;
      case 'b': epass1(15); break;
      case 'c': dpass1(11); break;
      case 'd': cpass1(7,p,r); break;
      case 'e': bpass1(0,p,r); break;
      case 'f': bpass1(1,p,r); break;
      case 'g': bpass1(2,p,r); break;
      case 'h': bpass1(3,p,r); break;
      case 'i': bpass1(4,p,r); break;
      case 'j': cpass1(8,p,r); break;
      case 'k': dpass1(12); break;
      case 'l': epass1(16); break;
      case 'm': fpass1(20); break;
    default: break;} break;

    case 'c': switch (s+'g') {
      case 'a': fpass1(17); break;
      case 'b': epass1(13); break;
      case 'c': dpass1(9); break;
      case 'd': cpass1(0,p,r); break;
      case 'e': cpass1(1,p,r); break;
      case 'f': cpass1(2,p,r); break;
      case 'g': cpass1(3,p,r); break;
      case 'h': cpass1(4,p,r); break;
      case 'i': cpass1(5,p,r); break;
      case 'j': cpass1(6,p,r); break;
      case 'k': dpass1(10); break;
      case 'l': epass1(14); break;
      case 'm': fpass1(18); break;
    default: break;} break;

    case 'd': switch (s+'g') {
      case 'a': fpass1(15); break;
      case 'b': epass1(11); break;
      case 'c': dpass1(0); break;
      case 'd': dpass1(1); break;
      case 'e': dpass1(2); break;
      case 'f': dpass1(3); break;
      case 'g': dpass1(4); break;
      case 'h': dpass1(5); break;
      case 'i': dpass1(6); break;
      case 'j': dpass1(7); break;
      case 'k': dpass1(8); break;
      case 'l': epass1(12); break;
      case 'm': fpass1(16); break;
    default: break;} break;

    case 'e': switch (s+'g') {
      case 'a': fpass1(13); break;
      case 'b': epass1(0); break;
      case 'c': epass1(1); break;
      case 'd': epass1(2); break;
      case 'e': epass1(3); break;
      case 'f': epass1(4); break;
      case 'g': epass1(5); break;
      case 'h': epass1(6); break;
      case 'i': epass1(7); break;
      case 'j': epass1(8); break;
      case 'k': epass1(9); break;
      case 'l': epass1(10); break;
      case 'm': fpass1(14); break;
    default: break;} break;

    case 'f': switch (s+'g') {
      case 'a': fpass1(0); break;
      case 'b': fpass1(1); break;
      case 'c': fpass1(2); break;
      case 'd': fpass1(3); break;
      case 'e': fpass1(4); break;
      case 'f': fpass1(5); break;
      case 'g': fpass1(6); break;
      case 'h': fpass1(7); break;
      case 'i': fpass1(8); break;
      case 'j': fpass1(9); break;
      case 'k': fpass1(10); break;
      case 'l': fpass1(11); break;
      case 'm': fpass1(12); break;
    default: break;} break;
  default: break;
  }
}

/* clear edijn screen and set up menu */
void clijn() {
  scrrul();
  printf("de Bruijn ring \n");
  printf("OPQabcRST (x,1)\n");
  printf("UVdefghWX (x,2)\n");
  printf("YijklmnoZ (x,3)\n");
  printf("pqrstuvwx (x,4)\n");
  printf(" 123456-diagram\n");
  printf("   ABC  0*1*2* \n");
  printf("   DEF  -1,0,1 \n");
  printf("   GHI  full n*\n");
  printf("y - cycles 1-8 \n");
  printf("+-  -   palette\n");
  printf("<?> cll,hlp,clr\n");
  printf("<cr>  - exit   \n\n");
}


/* edit the Pass 4 and Pass 5 (sample loops) shift displays */
void edshf(g,s,c) int g, s, c; {
    switch(shflev(g,s)) {
    case 0: apass5(c); break;
    case 1: bpass5(c); break;
    case 2: cpass5(c); break;
    case 3: dpass5(c); break;
    case 4: epass5(c); break;
    case 5: fpass5(c); break;
    default: break;}
}

/* edit the Pass 5 (sample loops) constant displays */
void edshc(g,c) int g, c; {
  switch(g) {
    case 0:  apass5(c); break;
    case 1:  bpass5(c); break;
    case 2:  cpass5(c); break;
    case 3:  dpass5(c); break;
    case 4:  epass5(c); break;
    case 5:  fpass5(c); break;
    default: break;}
}
/* find the level of de Bruijn diagram appropriate to g, s  */
int shflev(g,s) int g, s; {int  i;
	i=s<0?-s:s;
	if (i<g+2) i=g; else i--;
	return i;
}

int permut(k,n) int k, n; {
  switch (n) {
    case 0:  break;
    case 1:  k=(k+1)%KK; break;
    default: break;}
  return k;
}

/* edit the Pass 4 and Pass 5 (sample loops) shift displays */
void edshg(g,s) int g, s; {
    switch(shflev(g,s)) {
    case 0: apass6(); break;
    case 1: bpass6(); break;
    case 2: cpass6(); break;
    case 3: dpass6(); break;
    case 4: epass6(); break;
    case 5: fpass6(); break;
    default: break;}
}

/* edit the Pass 4 and Pass 5 (sample loops) constant displays */
void edcst(s) int s; {
    switch(s) {
    case 0: apass6(); break;
    case 1: bpass6(); break;
    case 2: cpass6(); break;
    case 3: dpass6(); break;
    case 4: epass6(); break;
    case 5: fpass6(); break;
    default: break;}
}

/* increment ix */ 
void incix(ix,n) int *ix, n; {int i; 
  for (i=0; i<n; i++) {
    ix[i]++;
    if (ix[i]>=KK) ix[i]=0; else return;
    }
}

/* selected node in ix */ 
void nodix(ix,n) int *ix, n; {int i, j; 
  j=dbno;
  for (i=0; i<n; i++) {ix[n-i-1]=j%KK; j/=KK;}
}

/* random number in ix */ 
void ranix(ix,n) int *ix, n; {int i, j; 
  j=random();
  for (i=0; i<n; i++) {ix[i]=j%KK; j/=KK;}
}

/* clear ix */ 
void zerix(ix,n) int *ix, n; {int i; for (i=0; i<n; i++) ix[i]=0;}

/* find index of nearest center to x, y (de Bruijn) */
int nearest(x,y) double x, y; {int i, k; double ex, wy, r, p;
k=0; p=500000.0;
for (i=0; i<dd; i++) {
  if (dbtag[i]==1) {
    ex=x-dcntr[i][0];
    wy=y-dcntr[i][1];
    r=ex*ex+wy*wy;
    if (r<p) {p=r; k=i;}
    }
  }
return k;
}

/* generate a de Bruijn diagram with m nodes, n links per node, color l */
void ijn(m,n,l) int m, n, l; {
int    i, j;
double ii, jj, nn, x, y, t, h;
// printf("ijn (m,n,l) - %3d, %3d, %3d\n",m,n,l);
nn=(double)(n);
t=6.28318/((double)(m));
h=0.5*t;
for (i=0; i<m; i++) {
  ii=(double)(i);
  for (j=0; j<n; j++) {
    jj=(double)(j);
    x=JX-RO*sin(ii*t+h);
    y=JY-RO*cos(ii*t+h);
    videoline(x,y,0);
    x=JX-RO*sin((nn*ii+jj)*t+h);
    y=JY-RO*cos((nn*ii+jj)*t+h);
    videoline(x,y,l);
    }
  }
}

/* insert a link into a de Bruijn diagram */
/* u - initial vertex     */
/* v - terminal vertex    */
/* l - color of link	  */

void lijnk(u,v,l) int u, v, l; {
char   s[10];
double x, y, ex, wy, eks, wye, dx, dy, r, w, t, sx, sy;

	if (l<KK) NXSetColor(colst[l]); else PSsetgray(NX_BLACK);
	r=10.3;
	w=3.33;
	ex=dcntr[u][0];
	wy=dcntr[u][1];
	x=dcntr[v][0];
	y=dcntr[v][1];
	dx=x-ex;
	dy=y-wy;
	t=atan2(dy,dx);
	sx=-w*sin(t);
	sy= w*cos(t);
	eks=x-r*cos(t)+sx;
	wye=y-r*sin(t)+sy;
	PSmoveto(ex+sx,wy+sy);
	PSlineto(eks,wye);
	PSlineto(eks-0.1*dx+0.05*dy,wye-0.1*dy-0.05*dx);
	PSlineto(eks-0.1*dx-0.05*dy,wye-0.1*dy+0.05*dx);
	PSlineto(eks,wye);
	PSstroke();

	PSmoveto(x+10.3,y);
	NXSetColor(colst[v%KK]);
	PSarc(x, y, 10.3, 0.0, 360.0);
	PSstroke();

   PSsetgray(NX_BLACK); 

   ex=dcntr[u][0];
   wy=dcntr[u][1];
   PSmoveto(ex-10.0,wy+5.0);
	sprintf(s,"%3d",u);
   PSshow(s);

   ex=dcntr[v][0];
   wy=dcntr[v][1];
   PSmoveto(ex-10.0,wy+5.0);
	sprintf(s,"%3d",v);
   PSshow(s);
   PSstroke();

}

/* generate a de Bruijn diagram showing ancestors of state k in color l */
void sijn(k,l) int k, l; {
int    i0, i1, i2;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  if (k==ascrule[i0][i1][i2]-'0') lijnk(i1+KK*i0,i2+KK*i1,l);
}

/* generate a de Bruijn diagram showing the (1,k) links in color l */
void zijn(m,k,l) int m, k, l; {
int    i, i0, i1, i2;
double th, x, y, t, h;
t=6.28318/((double)(m));
h=0.5*t;
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
  i=ascrule[i0][i1][i2]-'0';
  if ((k==0 && i==i0) || (k==1 && i==i1) || (k==2 && i==i2)) {
    th=((double)(i0*KK+i1))*t+h;
    x=JX-RI*sin(th);
    y=JY-RI*cos(th);
    videoline(x,y,0);
    th=((double)(i1*KK+i2))*t+h;
    x=JX-RO*sin(th);
    y=JY-RO*cos(th);
    videoline(x,y,l);
    }	/* end if    */
  }}}   /* end for's */
}	/* end zijn  */

/* plot graph on video screen 		   */
/* move pen from present position to (x,y) */
/* raised if l=0; color l if l>0	   */
void videoline(x,y,l) double x, y; int l; {
// printf("x,y,l = %6.3f, %6.3f, %3d.\n",x,y,l);
if (l==0) PSmoveto(400.0*x,400.0*y);
else PSlineto(400.0*x,400.0*y);
}

/* - - - - - - - - - d e   B r u i j n - - - - - - - - - - - - - - - - - - */

/* = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = */

/* ONE21.C */

/* Pass 1a analyzes all the configurations which fulfil (-1+l,1) */
void apass1(l,p,r) int l, p, r; {
int  ix[RR], m;
asctobin();
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++) {
  m=permut(ix[l],p);
  aarry[ix[0]][ix[1]][ix[2]]=binrule[ix[0]][ix[1]][ix[2]]==m?'Y':'N';
  }
if (r) {apass2i(); apass2o();}
}

/* Pass 1x analyzes all the configurations mapping into a constant */
void xpass1(l) int l; {
int  ix[RR], m;
m=l;
asctobin();
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++) {
  aarry[ix[0]][ix[1]][ix[2]]=binrule[ix[0]][ix[1]][ix[2]]==m?'Y':'N';
  }
apass2i();
apass2o();
}

/* Pass 2i flags all links with an incoming arrow */
/* Pass 2o flags all links with an outgoing arrow */
/* Then pass 3 discards all unflagged links */
/* Passes 2 and 3 alternate until no change is observed */

void apass2i() {int i,j,k,m;
do {
for (i=0; i<KK; i++)
for (j=0; j<KK; j++)
for (k=0; k<KK; k++) {
if ((aarry[i][j][k]&0x5F)=='Y') {for (m=0; m<KK; m++) aarry[j][k][m]|=0x20;}
}
   } while (apass3()!=0); }

void apass2o() {int i,j,k,m;
do {
for (i=0; i<KK; i++)
for (j=0; j<KK; j++)
for (k=0; k<KK; k++) {
if ((aarry[i][j][k]&0x5F)=='Y') {for (m=0; m<KK; m++) aarry[m][i][j]|=0x20;}
}
   } while (apass3()!=0); }

/* Pass 3 - erase flags, mark survivors, count changes */

int apass3() {int i,j,k,l;
l=0;
for (i=0; i<KK; i++)
for (j=0; j<KK; j++)
for (k=0; k<KK; k++) {
  switch (aarry[i][j][k]) {
    case 'y': aarry[i][j][k]='Y'; break;
    case 'Y': aarry[i][j][k]='N'; l=1; break;
    case 'n': case 'N': aarry[i][j][k]='N'; break;
    default: break; }
  }
return l;
}

/* Pass4 - print loops which remain */
void apass4() {
int i0, i1, i2;
int j0, j1, j2;
int k, l, m;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) {
j0=i0; j1=i1; j2=i2; l=0; m=0;
do {
        if (aarry[0][j1][j2]=='Y')
    {aarry[0][j1][j2]='y';
    k=j2; j2=j1; j1=0; m=1;}
  else {if (aarry[1][j1][j2]=='Y')
    {aarry[1][j1][j2]='y';
    k=j2; j2=j1; j1=1; m=1;}
  else {l=1; if (m==1) {j0=j1; j1=j2; j2=k;} }}
  } while (l==0);
l=0; 
m=0;
do {
        if (aarry[j0][j1][0]=='y')
   {aprf(j0,j1,0);
   aarry[j0][j1][0]='N';
   j0=j1; j1=0; m=1;}
  else {if (aarry[j0][j1][1]=='y')
   {aprf(j0,j1,1);
   aarry[j0][j1][1]='N';
   j0=j1; j1=1; m=1;}
  else {l=1;}}
  } while (l==0);
l=0;
do {
        if (aarry[j0][j1][0]=='Y')
   {aprf(j0,j1,0);
   aarry[j0][j1][0]='N';
   j0=j1; j1=0; m=1;}
  else {if (aarry[j0][j1][1]=='Y')
   {aprf(j0,j1,1);
   aarry[j0][j1][1]='N';
   j0=j1; j1=1; m=1;}
  else {l=1;}}
  } while (l==0);
}
}

/* print one link of the de Bruijn diagram */
void aprf(i,j,k) int i, j, k; {
// printf("%1d",i);
// printf("%1d",j);
// printf("-");
// printf("%1d",k);
// printf("  ");
// lijnk(dd,i*KK+j,j*KK+k,3);
}

/* Pass 5 (sample loops) - show evolution of sample loops */
void apass5(c) char c; {
int i0, i1, i2;
int j1;
int hl;
int b[KK], irry[RR], i, j, k, l;
  switch (c) {
    case 'z': zerix(irry,RR); break;
    case 'r': ranix(irry,RR); break;
    case 'n': nodix(irry,RR-1);
	i0=irry[0]; i1=irry[1];
	for (i=j=0; j<KK; j++) if (aarry[i0][i1][j]=='Y') {b[i]=j; i++;}
	if (i==0) return;
	l=0; if (i>1) l=random()%i;
	irry[RR-1]=b[l];
	break;
    case 'i': incix(irry,RR); break;
    default:  zerix(irry,RR); break;}
  i0=irry[0]; i1=irry[1]; i2=irry[2];
for (k=0; k<8; k++) {
  if (aarry[i0][i1][i2]=='Y') break;
  incix(irry,RR);
  i0=irry[0]; i1=irry[1]; i2=irry[2];
  }
hl=AL/2;
arr1[hl-1]=i0;
arr1[hl  ]=i1;
arr1[hl+1]=i2;
j1=i1;
for (k=hl-2; k>=0; k--) {
  for (i=j=0; j<KK; j++) if (aarry[j][i0][i1]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=random()%i;
  i1=i0; i0=arr1[k]=b[l];
  }
i1=j1;
for (k=hl+2; k<AL; k++) {
  for (i=j=0; j<KK; j++) if (aarry[i1][i2][j]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=random()%i;
  i1=i2; i2=arr1[k]=b[l];
  }
}

void apass6() {int i, j, i0, i1, i2;
for (i=0; i<DDN; i++) dbtag[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) {
  i=i0*KK+i1;
  j=i1*KK+i2;
  if(aarry[i0][i1][i2]=='Y') {
	dbtag[i]=1;
	dbtag[j]=1;
	lijnk(i,j,3);
	}
  }
}

/* TWO21.C */

/* mark sequences conforming to (-2+l,2) */
void bpass1(l,p,r) int l, p, r; {
int ix[2*RR-1], jx[RR], kx;
int i, m, n;
asctobin();
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++)
for (ix[3]=0; ix[3]<KK; ix[3]++)
for (ix[4]=0; ix[4]<KK; ix[4]++) {
  for (i=0; i<RR; i++) jx[i]=binrule[ix[i]][ix[i+1]][ix[i+2]];
  kx=binrule[jx[0]][jx[1]][jx[2]];
  if (l<5) {m=ix[l]; n=kx;}
  if (l==5) {m=ix[0]; n=jx[1];}
  if (l==6) {m=ix[4]; n=jx[1];}
  barry[ix[0]][ix[1]][ix[2]][ix[3]][ix[4]]=m==permut(n,p)?'Y':'N';
  }
if (r) {bpass2i(); bpass2o();}
}

/* Pass 1y analyzes all the configurations mapping into a constant */
void ypass1(l) int l; {
int ix[2*RR-1], jx[RR], kx;
int i;
asctobin();
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++)
for (ix[3]=0; ix[3]<KK; ix[3]++)
for (ix[4]=0; ix[4]<KK; ix[4]++) {
  for (i=0; i<RR; i++) jx[i]=binrule[ix[i]][ix[i+1]][ix[i+2]];
  kx=binrule[jx[0]][jx[1]][jx[2]];
  barry[ix[0]][ix[1]][ix[2]][ix[3]][ix[4]]=kx==l?'Y':'N';
  }
bpass2i();
bpass2o();
}

/* Passs 2i flags links which have an incoming arrow */
void bpass2i() {
int i0, i1, i2, i3, i4, m;
do {
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
if ((barry[i0][i1][i2][i3][i4]&0x5F)=='Y')
 {for (m=0; m<KK; m++) barry[i1][i2][i3][i4][m]|=0x20;}
}
} while (bpass3()!=0); }

/* Passs 2o flags links which have an outgoing arrow */
void bpass2o() {
int i0, i1, i2, i3, i4, m;
do {
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
if ((barry[i0][i1][i2][i3][i4]&0x5F)=='Y')
 {for (m=0; m<KK; m++) barry[m][i0][i1][i2][i3]|=0x20;}
}
} while (bpass3()!=0); }

/*  Pass 3 erases flags, marks survivors, counts changes */
int bpass3() {
int i0, i1, i2, i3, i4, l;
l=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
switch (barry[i0][i1][i2][i3][i4]) {
    case 'y': barry[i0][i1][i2][i3][i4]='Y'; break;
    case 'Y': barry[i0][i1][i2][i3][i4]='N'; l=1; break;
    case 'n': case 'N': barry[i0][i1][i2][i3][i4]='N'; break;
    default: break; }
}
return l;
}

/* Pass 4 prints loops which remain */
void bpass4() {
int i0, i1, i2, i3, i4;
int j0, j1, j2, j3, j4, k, l, m;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
j0=i0; j1=i1; j2=i2; j3=i3; j4=i4; l=0; m=0;
do {
        if (barry[0][j1][j2][j3][j4]=='Y')
    {barry[0][j1][j2][j3][j4]='y';
    k=j4; j4=j3; j3=j2; j2=j1; j1=0; m=1;}
  else {if (barry[1][j1][j2][j3][j4]=='Y')
    {barry[1][j1][j2][j3][j4]='y';
    k=j4; j4=j3; j3=j2; j2=j1; j1=1; m=1;}
  else {l=1; if (m==1) {j0=j1; j1=j2; j2=j3; j3=j4; j4=k;} }}
  } while (l==0);
l=0; 
m=0;
do {
        if (barry[j0][j1][j2][j3][0]=='y')
   {bprf(j0,j1,j2,j3,0);
   barry[j0][j1][j2][j3][0]='N';
   j0=j1; j1=j2; j2=j3; j3=0; m=1;}
  else {if (barry[j0][j1][j2][j3][1]=='y')
   {bprf(j0,j1,j2,j3,1);
   barry[j0][j1][j2][j3][1]='N';
   j0=j1; j1=j2; j2=j3; j3=1; m=1;}
  else {l=1;}}
  } while (l==0);
l=0;
do {
        if (barry[j0][j1][j2][j3][0]=='Y')
   {bprf(j0,j1,j2,j3,0);
   barry[j0][j1][j2][j3][0]='N';
   j0=j1; j1=j2; j2=j3; j3=0; m=1;}
  else {if (barry[j0][j1][j2][j3][1]=='Y')
   {bprf(j0,j1,j2,j3,1);
   barry[j0][j1][j2][j3][1]='N';
   j0=j1; j1=j2; j2=j3; j3=1; m=1;}
  else {l=1;}}
  } while (l==0);
}
}

/* print one of the links in a chain */
void bprf(i0,i1,i2,i3,i4) int i0, i1, i2, i3, i4; {
// printf("%1d",i0);
// printf("%1d",i1);
// printf("%1d",i2);
// printf("%1d",i3);
// printf("-");
// printf("%1d",i4);
// printf(" ");
// lijnk(dd,((i0*KK+i1)*KK+i2)*KK+i3,((i1*KK+i2)*KK+i3)*KK+i4,3);
}

/* Pass 5 (sample loops) - show evolution of sample loops */
void bpass5(c) char c; {
int i0, i1, i2, i3, i4;
int j1, j2, j3;
int hl;
int b[KK], irry[2*RR-1], i, j, k, l;
  switch (c) {
    case 'z': zerix(irry,2*RR-1); break;
    case 'r': ranix(irry,2*RR-1); break;
    case 'n': nodix(irry,2*RR-2);
  i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3];
  for (i=j=0; j<KK; j++) if (barry[i0][i1][i2][i3][j]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=random()%i;
  irry[2*RR-2]=b[l];
  break;
    case 'i': incix(irry,2*RR-1); break;
    default:  zerix(irry,2*RR-1); break;}
  i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3]; i4=irry[4];
for (k=0; k<81; k++) {
  if (barry[i0][i1][i2][i3][i4]=='Y') break;
  incix(irry,2*RR-1);
  i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3]; i4=irry[4];
  }
hl=AL/2;
arr1[hl-2]=i0;
arr1[hl-1]=i1;
arr1[hl  ]=i2;
arr1[hl+1]=i3;
arr1[hl+2]=i4;
j1=i1; j2=i2; j3=i3;
for (k=hl-3; k>=0; k--) {
  for (i=j=0; j<KK; j++) if (barry[j][i0][i1][i2][i3]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=random()%i;
  i3=i2; i2=i1; i1=i0; i0=arr1[k]=b[l];
  }
i1=j1; i2=j2; i3=j3;
for (k=hl+3; k<AL; k++) {
  for (i=j=0; j<KK; j++) if (barry[i1][i2][i3][i4][j]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=random()%i;
  i1=i2; i2=i3; i3=i4; i4=arr1[k]=b[l];
  }
}

void bpass6() {int i, j, i0, i1, i2, i3, i4;
for (i=0; i<DDN; i++) dbtag[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
  i=((i0*KK+i1)*KK+i2)*KK+i3;
  j=((i1*KK+i2)*KK+i3)*KK+i4;
  if(barry[i0][i1][i2][i3][i4]=='Y') {
	dbtag[i]=1;
	dbtag[j]=1;
	lijnk(i,j,3);
	}
  }
}

/* THREE21.C */

/* mark sequences conforming to (-3+l,3) */
void cpass1(l,p,r) int l, p, r; {
int  ix[RR+4], jx[2*RR-1], kx[RR], lx;
int  i, m, n;
asctobin();
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++)
for (ix[3]=0; ix[3]<KK; ix[3]++)
for (ix[4]=0; ix[4]<KK; ix[4]++)
for (ix[5]=0; ix[5]<KK; ix[5]++)
for (ix[6]=0; ix[6]<KK; ix[6]++) {
  for (i=0; i<5; i++) jx[i]=binrule[ix[i]][ix[i+1]][ix[i+2]];
  for (i=0; i<3; i++) kx[i]=binrule[jx[i]][jx[i+1]][jx[i+2]];
  lx=binrule[kx[0]][kx[1]][kx[2]];
switch (l) {
  case 0:  m=ix[0]; n=lx; break;
  case 1:  m=ix[1]; n=lx; break;
  case 2:  m=ix[2]; n=lx; break;
  case 3:  m=ix[3]; n=lx; break;
  case 4:  m=ix[4]; n=lx; break;
  case 5:  m=ix[5]; n=lx; break;
  case 6:  m=ix[6]; n=lx; break;
  case 7:  m=ix[0]; n=kx[1]; break;
  case 8:  m=ix[6]; n=kx[1]; break;
  case 9:  m=ix[0]; n=jx[2]; break;
  case 10: m=ix[6]; n=jx[2]; break;
  default: break;}
carry[ix[0]][ix[1]][ix[2]][ix[3]][ix[4]][ix[5]][ix[6]]=m==permut(n,p)?'Y':'N';
}
if (r) {cpass2i(); cpass2o();}
}

/* Pass 1z analyzes all the configurations mapping into a constant */
void zpass1(l) int l; {
int  ix[3*RR-2], jx[2*RR-1], kx[RR], lx;
int  i, m, n;
asctobin();
for (ix[0]=0; ix[0]<KK; ix[0]++)
for (ix[1]=0; ix[1]<KK; ix[1]++)
for (ix[2]=0; ix[2]<KK; ix[2]++)
for (ix[3]=0; ix[3]<KK; ix[3]++)
for (ix[4]=0; ix[4]<KK; ix[4]++)
for (ix[5]=0; ix[5]<KK; ix[5]++)
for (ix[6]=0; ix[6]<KK; ix[6]++) {
  for (i=0; i<5; i++) jx[i]=binrule[ix[i]][ix[i+1]][ix[i+2]];
  for (i=0; i<3; i++) kx[i]=binrule[jx[i]][jx[i+1]][jx[i+2]];
  lx=binrule[kx[0]][kx[1]][kx[2]];
carry[ix[0]][ix[1]][ix[2]][ix[3]][ix[4]][ix[5]][ix[6]]=lx==l?'Y':'N';
}
cpass2i();
cpass2o();
}

/* Pass 2i flags links which have an incoming arrow */
void cpass2i() {
int i0, i1, i2, i3, i4, i5, i6, m;
do {
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++) {
if ((carry[i0][i1][i2][i3][i4][i5][i6]&0x5F)=='Y')
 {for (m=0; m<KK; m++) carry[i1][i2][i3][i4][i5][i6][m]|=0x20;}
}
} while (cpass3()!=0); }

/* Pass 2o flags links which have an outgoing arrow */
void cpass2o() {
int i0, i1, i2, i3, i4, i5, i6, m;
do {
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++) {
if ((carry[i0][i1][i2][i3][i4][i5][i6]&0x5F)=='Y')
 {for (m=0; m<KK; m++) carry[m][i0][i1][i2][i3][i4][i5]|=0x20;}
}
} while (cpass3()!=0); }

/*  Pass 3 erases flags, marks survivors, counts channges */
int cpass3() {
int i0, i1, i2, i3, i4, i5, i6, l;
l=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++) {
switch (carry[i0][i1][i2][i3][i4][i5][i6]) {
    case 'y': carry[i0][i1][i2][i3][i4][i5][i6]='Y'; break;
    case 'Y': carry[i0][i1][i2][i3][i4][i5][i6]='N'; l=1; break;
    case 'n': case 'N': carry[i0][i1][i2][i3][i4][i5][i6]='N'; break;
    default: break; }
}
return l; }

/* Pass 4 prints loops which remain */
void cpass4() {
int i0, i1, i2, i3, i4, i5, i6;
int j0, j1, j2, j3, j4, j5, j6;
int  k, l, m;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++) {
j0=i0; j1=i1; j2=i2; j3=i3; j4=i4; j5=i5; j6=i6;
l=0;
m=0;
do {
        if (carry[0][j1][j2][j3][j4][j5][j6]=='Y')
    {carry[0][j1][j2][j3][j4][j5][j6]='y';
    k=j6; j6=j5; j5=j4; j4=j3; j3=j2; j2=j1; j1=0; m=1;}
  else {if (carry[1][j1][j2][j3][j4][j5][j6]=='Y')
    {carry[1][j1][j2][j3][j4][j5][j6]='y';
    k=j6; j6=j5; j5=j4; j4=j3; j3=j2; j2=j1; j1=1; m=1;}
  else {l=1;
    if (m==1) {j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=k;}
    }}
  } while (l==0);
l=0; 
m=0;
do {
        if (carry[j0][j1][j2][j3][j4][j5][0]=='y')
   {cprf(j0,j1,j2,j3,j4,j5,0);
   carry[j0][j1][j2][j3][j4][j5][0]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=0; m=1;}
  else {if (carry[j0][j1][j2][j3][j4][j5][1]=='y')
   {cprf(j0,j1,j2,j3,j4,j5,1);
   carry[j0][j1][j2][j3][j4][j5][1]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=1; m=1;}
  else {l=1;}}
  } while (l==0);
l=0;
do {
        if (carry[j0][j1][j2][j3][j4][j5][0]=='Y')
   {cprf(j0,j1,j2,j3,j4,j5,0);
   carry[j0][j1][j2][j3][j4][j5][0]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=0; m=1;}
  else {if (carry[j0][j1][j2][j3][j4][j5][1]=='Y')
   {cprf(j0,j1,j2,j3,j4,j5,1);
   carry[j0][j1][j2][j3][j4][j5][1]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=1; m=1;}
  else {l=1;}}
  } while (l==0);
}
}

/* print one of the individual links in a chain */
void cprf(i0,i1,i2,i3,i4,i5,i6)
int i0, i1, i2, i3, i4, i5, i6; {int i, j;
// printf("%1d",i0);
// printf("%1d",i1);
// printf("%1d",i2);
// printf("%1d",i3);
// printf("%1d",i4);
// printf("%1d",i5);
// printf("-");
// printf("%1d",i6);
// printf(" ");
// i=((((i0*KK+i1)*KK+i2)*KK+i3)*KK+i4)*KK+i5;
// j=((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6;
// lijnk(dd,i,j,3);
}

/* Pass 5 (sample loops) - show evolution of sample loops */
void cpass5(c) char c; {
int i0, i1, i2, i3, i4, i5, i6;
int j1, j2, j3, j4, j5;
int hl;
int irry[RR+4], b[RR], i, j, k, l;
  switch (c) {
    case 'z': zerix(irry,RR+4); break;
    case 'r': ranix(irry,RR+4); break;
    case 'n': nodix(irry,RR+3);
  i0=irry[0]; i1=irry[1]; i2=irry[2];
  i3=irry[3]; i4=irry[4]; i5=irry[5];
  for (i=j=0; j<KK; j++) 
	if (carry[i0][i1][i2][i3][i4][i5][j]=='Y') {b[i]=j; i++;}
	if (i==0) return;
	l=0; if (i>1) l=random()%i;
	irry[6]=b[l];
	break;
    case 'i': incix(irry,RR+4); break;
    default:  zerix(irry,RR+4); break;}
  i0=irry[0]; i1=irry[1]; i2=irry[2];
  i3=irry[3]; i4=irry[4]; i5=irry[5]; i6=irry[6];
for (k=0; k<729; k++) {
  if (carry[i0][i1][i2][i3][i4][i5][i6]=='Y') break;
  incix(irry,RR+4);
  i0=irry[0]; i1=irry[1]; i2=irry[2];
  i3=irry[3]; i4=irry[4]; i5=irry[5]; i6=irry[6];
  }
hl=AL/2;
arr1[hl-3]=i0;
arr1[hl-2]=i1;
arr1[hl-1]=i2;
arr1[hl]=i3;
arr1[hl+1]=i4;
arr1[hl+2]=i5;
arr1[hl+3]=i6;
j1=i1; j2=i2; j3=i3; j4=i4; j5=i5;
for (k=hl-4; k>=0; k--) {
  for (i=j=0; j<KK; j++) if (carry[j][i0][i1][i2][i3][i4][i5]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=random()%i;
  i5=i4; i4=i3; i3=i2; i2=i1; i1=i0; i0=arr1[k]=b[l];
  }
i1=j1; i2=j2; i3=j3; i4=j4; i5=j5;
for (k=hl+4; k<AL; k++) {
  for (i=j=0; j<KK; j++) if (carry[i1][i2][i3][i4][i5][i6][j]=='Y') {b[i]=j; i++;}
  if (i==0) return;
  l=0; if (i>1) l=random()%i;
  i1=i2; i2=i3; i3=i4; i4=i5; i5=i6; i6=arr1[k]=b[l];
  }
}

void cpass6() {int i, j, i0, i1, i2, i3, i4, i5, i6;
for (i=0; i<DDN; i++) dbtag[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++) {
  i=((((i0*KK+i1)*KK+i2)*KK+i3)*KK+i4)*KK+i5;
  j=((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6;
  if(carry[i0][i1][i2][i3][i4][i5][i6]=='Y') {
	dbtag[i]=1;
	dbtag[j]=1;
	lijnk(i,j,3);
	}
  }
}

/* end nxrijn21.c */
