# ifdef SYSV
# include <termio.h>

static inflag = 0;
static struct termio ttysv, ttyraw;

r_ttget()
{
    if (ioctl(0,TCGETA,&ttysv) == -1)
	return;
    if (ioctl(0,TCGETA,&ttyraw) == -1)
	return;
    ttyraw.c_lflag &= ~(ISIG | ICANON | ECHO | ECHOE | ECHONL);
    ttyraw.c_oflag &= ~OPOST;
    ttyraw.c_iflag = IGNPAR | IGNBRK;
    ttyraw.c_cc[VEOF] = 1;
    ttyraw.c_cc[VEOL] = 0;
    inflag = 1;
}

r_ttset()
{
    if (inflag)
	if (ioctl(0,TCSETA,&ttyraw) == -1)
	    r_errterm("Error setting raw tty");
}

r_ttreset()
{
    if (inflag)
	if (ioctl(0,TCSETA,&ttysv) == -1)
	    r_errterm("Error setting original tty");
}
# endif

# ifdef BSD
# include <sgtty.h>

static inflag = 0;
static struct sgttyb ttysv, ttyraw;

r_ttget()
{
    if (ioctl(0,TIOCGETP,&ttysv) == -1)
	return;
    if (ioctl(0,TIOCGETP,&ttyraw) == -1)
	return;
    ttyraw.sg_flags = (ttyraw.sg_flags | CBREAK) & ~(ECHO | CRMOD);
    inflag = 1;
}

r_ttset()
{
    if (inflag)
	if (ioctl(0,TIOCSETP,&ttyraw) == -1)
	    r_errterm("Error setting raw tty");
}

r_ttreset()
{
    if (inflag)
	if (ioctl(0,TIOCSETP,&ttysv) == -1)
	    r_errterm("Error setting original tty");
}
# endif

# ifdef MSDOS
/* Wizard C ioctl, based on MS-DOS' ioctl */
# define TCGETA	0	/* get device information */
# define TCSETA 1	/* set device information */
# define CHDEV	0200	/* bit indicating character device */
# define RAW	0040	/* bit indicationg raw mode */
# define LOWB	0377	/* mask for selection of low-order byte */

static inflag = 0;
static int ttysv, ttyraw;

r_ttget()
{
    if ((ttysv = ioctl(0,TCGETA,0,0)) == -1)
	return;
    if ((ttyraw = ioctl(0,TCGETA,0,0)) == -1)
	return;
    if ((ttysv & CHDEV) == 0)
	return;
    ttyraw = (ttyraw | RAW) & LOWB;
    ttysv &= LOWB;
    inflag = 1;
}

r_ttset()
{
    if (inflag)
	if (ioctl(0,TCSETA,ttyraw,0) == -1)
	    r_errterm("Error setting raw tty");
}

r_ttreset()
{
    if (inflag)
	if (ioctl(0,TCSETA,ttysv,0) == -1)
	    r_errterm("Error setting original tty");
}
# endif
